//==========================================================================
// File : NSEShlWapi.pas
//
// Definitions for shell functions in Delphi, according to the August 2002
// version of the Microsoft Platform SDK
//
// Author : K. Giddings
//
//
// This file is part of the NSELib library for Delphi.
// NSELib can be found on the web on this URL:
// http://www.whirlingdervishes.com/nselib
// The documentation can be found at this URL:
// http://www.whirlingdervishes.com/nselib/help
//
// This source code is the property of its authors and may not be
// redistributed or reproduced in any form without the written
// permission of the authors.
//
// You may freely use this unit in the creation of any software. 
//
// Copyright (C) 1998-2006 Whirling Dervishes Software
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
//==========================================================================
unit NSEShlWApi;

interface

uses Windows, ActiveX, ShlObj;

//
//=============== String Routines ===================================
//

function StrChrA(const lpStart : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;
function StrChrW(const lpStart : PWideChar; wMatch : word) : PWideChar; stdcall;
function StrChr(const lpStart : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;

function StrChrIA(const lpStart : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;
function StrChrIW(const lpStart : PWideChar; wMatch : word) : PWideChar; stdcall;
function StrChrI(const lpStart : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;

function StrCmpNA(const lpStr1, lpStr2 : PAnsiChar; nChar : integer) : integer; stdcall;
function StrCmpNW(const lpStr1, lpStr2 : PWideChar; nChar : integer) : integer; stdcall;
function StrCmpN(const lpStr1, lpStr2 : PAnsiChar; nChar : integer) : integer; stdcall;

function StrCmpNIA(const lpStr1, lpStr2 : PAnsiChar; nChar : integer) : integer; stdcall;
function StrCmpNIW(const lpStr1, lpStr2 : PWideChar; nChar : integer) : integer; stdcall;
function StrCmpNI(const lpStr1, lpStr2 : PAnsiChar; nChar : integer) : integer; stdcall;

function StrCSpnA(const lpStr, lpSet : PAnsiChar) : integer; stdcall;
function StrCSpnW(const lpStr, lpSet : PWideChar) : integer; stdcall;
function StrCSpn(const lpStr, lpSet : PAnsiChar) : integer; stdcall;

function StrCSpnIA(const lpStr, lpSet : PAnsiChar) : integer; stdcall;
function StrCSpnIW(const lpStr, lpSet : PWideChar) : integer; stdcall;
function StrCSpnI(const lpStr, lpSet : PAnsiChar) : integer; stdcall;

function StrDupA(const lpSrch : PAnsiChar) : PAnsiChar; stdcall;
function StrDupW(const lpSrch : PWideChar) : PWideChar; stdcall;
function StrDup(const lpSrch : PAnsiChar) : PAnsiChar; stdcall;

function StrFormatByteSizeA(dw: cardinal; szBuf: PAnsiChar; uiBufSize: cardinal): PAnsiChar; stdcall;
function StrFormatByteSizeW(dw: Int64; szBuf: PWideChar; uiBufSize: cardinal): PWideChar; stdcall;
function StrFormatByteSize(dw: cardinal; szBuf: PAnsiChar; uiBufSize: cardinal): PAnsiChar; stdcall;

function StrFormatByteSize64A(dw: Int64; szBuf: PAnsiChar; uiBufSize: cardinal): PAnsiChar; stdcall;
function StrFormatByteSize64(dw: Int64; szBuf: PAnsiChar; uiBufSize: cardinal): PAnsiChar; stdcall;

function StrFormatKBSizeA(qdw : Int64; szBuf : PAnsiChar; uiBufSize : cardinal) : PAnsiChar; stdcall;
function StrFormatKBSizeW(qdw : Int64; szBuf : PWideChar; uiBufSize : cardinal) : PWideChar; stdcall;
function StrFormatKBSize(qdw : Int64; szBuf : PAnsiChar; uiBufSize : cardinal) : PAnsiChar; stdcall;

function StrFromTimeIntervalA(pszOut : PAnsiChar; cchMax : cardinal; dwTimeMS : cardinal; digits : integer) : integer; stdcall;
function StrFromTimeIntervalW(pszOut : PWideChar; cchMax : cardinal; dwTimeMS : cardinal; digits : integer) : integer; stdcall;
function StrFromTimeInterval(pszOut : PAnsiChar; cchMax : cardinal; dwTimeMS : cardinal; digits : integer) : integer; stdcall;

function StrIsIntlEqualA(fCaseSens : bool; const lpString1, lpString2 : PAnsiChar; nChar : integer) : bool; stdcall;
function StrIsIntlEqualW(fCaseSens : bool; const lpString1, lpString2 : PWideChar; nChar : integer) : bool; stdcall;
function StrIsIntlEqual(fCaseSens : bool; const lpString1, lpString2 : PAnsiChar; nChar : integer) : bool; stdcall;

function StrNCatA(psz1 : PAnsiChar; const psz2 : PAnsiChar; cchMax : integer) : PAnsiChar; stdcall;
function StrNCatW(psz1 : PWideChar; const psz2 : PWideChar; cchMax : integer) : PWideChar; stdcall;
function StrNCat(psz1 : PAnsiChar; const psz2 : PAnsiChar; cchMax : integer) : PAnsiChar; stdcall;

function StrPBrkA(const psz,pszSet : PAnsiChar) : PAnsiChar; stdcall;
function StrPBrkW(const psz,pszSet : PWideChar) : PWideChar; stdcall;
function StrPBrk(const psz,pszSet : PAnsiChar) : PAnsiChar; stdcall;

function StrRChrA(const lpStart, lpEnd : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;
function StrRChrW(const lpStart, lpEnd : PWideChar; wMatch : word) : PWideChar; stdcall;
function StrRChr(const lpStart, lpEnd : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;

function StrRChrIA(const lpStart, lpEnd : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;
function StrRChrIW(const lpStart, lpEnd : PWideChar; wMatch : word) : PWideChar; stdcall;
function StrRChrI(const lpStart, lpEnd : PAnsiChar; wMatch : word) : PAnsiChar; stdcall;

function StrRStrIA(const lpSource, lpLast, lpSrch : PAnsiChar) : PAnsiChar; stdcall;
function StrRStrIW(const lpSource, lpLast, lpSrch : PWideChar) : PWideChar; stdcall;
function StrRStrI(const lpSource, lpLast, lpSrch : PAnsiChar) : PAnsiChar; stdcall;

function StrSpnA(const psz, pszSet : PAnsiChar) : integer; stdcall;
function StrSpnW(const psz, pszSet : PWideChar) : integer; stdcall;
function StrSpn(const psz, pszSet : PAnsiChar) : integer; stdcall;

function StrStrA(const lpFirst, lpSrch : PAnsiChar) : PAnsiChar; stdcall;
function StrStrW(const lpFirst, lpSrch : PWideChar) : PWideChar; stdcall;
function StrStr(const lpFirst, lpSrch : PAnsiChar) : PAnsiChar; stdcall;

function StrStrIA(const lpFirst, lpSrch : PAnsiChar) : PAnsiChar; stdcall;
function StrStrIW(const lpFirst, lpSrch : PWideChar) : PWideChar; stdcall;
function StrStrI(const lpFirst, lpSrch : PAnsiChar) : PAnsiChar; stdcall;

function StrToIntA(const lpSrc : PAnsiChar) : integer; stdcall;
function StrToIntW(const lpSrc : PWideChar) : integer; stdcall;
function StrToInt(const lpSrc : PAnsiChar) : integer; stdcall;

function StrToIntExA(const pszString : PAnsiChar; dwFlags : cardinal; var piRet : integer) : bool; stdcall;
function StrToIntExW(const pszString : PWideChar; dwFlags : cardinal; var piRet : integer) : bool; stdcall;
function StrToIntEx(const pszString : PAnsiChar; dwFlags : cardinal; var piRet : integer) : bool; stdcall;

function StrToInt64ExA(const pszString : PAnsiChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
function StrToInt64ExW(const pszString : PWideChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
function StrToInt64Ex(const pszString : PAnsiChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;

function StrTrimA(psz : PAnsiChar; const pszTrimChars : PAnsiChar) : bool; stdcall;
function StrTrimW(psz : PWideChar; const pszTrimChars : PWideChar) : bool; stdcall;
function StrTrim(psz : PAnsiChar; const pszTrimChars : PAnsiChar) : bool; stdcall;

function StrCatW(psz1 : PWideChar; const psz2 : PWideChar) : PWideChar; stdcall;
function StrCmpW(const psz1, psz2 : PWideChar) : integer; stdcall;
function StrCmpIW(const psz1, psz2 : PWideChar) : integer; stdcall;
function StrCpyW(const psz1, psz2 : PWideChar) : PWideChar; stdcall;
function StrCpyNW(psz1 : PWideChar; const psz2 : PWideChar; cchMax : integer) : PWideChar; stdcall;

function StrCatBuffA(pszDest : PAnsiChar; const pszSrc : PAnsiChar; cchDestBuffSize : integer) : PAnsiChar; stdcall;
function StrCatBuffW(pszDest : PWideChar; const pszSrc : PWideChar; cchDestBuffSize : integer) : PWideChar; stdcall;
function StrCatBuff(pszDest : PAnsiChar; const pszSrc : PAnsiChar; cchDestBuffSize : integer) : PAnsiChar; stdcall;

function ChrCmpIA(w1,w2 : WORD) : bool; stdcall;
function ChrCmpIW(w1, w2 : WideChar) : bool; stdcall;
function ChrCmpI(w1,w2 : WORD) : bool; stdcall;

function wvnsprintfA(lpOut: PAnsiChar; cchLimitIn : integer; lpFmt: PAnsiChar; arglist: va_list): Integer; stdcall;
function wvnsprintfW(lpOut: PWideChar; cchLimitIn : integer; lpFmt: PWideChar; arglist: va_list): Integer; stdcall;

function wnsprintfA(lpOut: PAnsiChar; cchLimitIn : integer; lpFmt: PAnsiChar): Integer; stdcall;
function wnsprintfW(lpOut: PWideChar; cchLimitIn : integer; lpFmt: PWideChar): Integer; stdcall;


function StrIntlEqNA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
function StrIntlEqNW(const s1, s2 : PWideChar; nChar : integer) : bool;
function StrIntlEqN(const s1, s2 : PAnsiChar; nChar : integer) : bool;

function StrIntlEqNIA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
function StrIntlEqNIW(const s1, s2 : PWideChar; nChar : integer) : bool;
function StrIntlEqNI(const s1, s2 : PAnsiChar; nChar : integer) : bool;

function StrRetToStrA(pstr : PSTRRET; const pidl : PITEMIDLIST; ppsz : PPAnsiChar) : HResult; stdcall;
function StrRetToStrW(pstr : PSTRRET; const pidl : PITEMIDLIST; ppsz : PPWideChar) : HResult; stdcall;
function StrRetToStr(pstr : PSTRRET; const pidl : PITEMIDLIST; ppsz : PPAnsiChar) : HResult; stdcall;

function StrRetToBufA(pStr : PSTRRET; const pidl : PITEMIDLIST; pszBuf : PAnsiChar; cchBuf : cardinal) : HResult; stdcall;
function StrRetToBufW(pStr : PSTRRET; const pidl : PITEMIDLIST; pszBuf : PWideChar; cchBuf : cardinal) : HResult; stdcall;
function StrRetToBuf(pStr : PSTRRET; const pidl : PITEMIDLIST; pszBuf : PAnsiChar; cchBuf : cardinal) : HResult; stdcall;

function StrRetToBSTR(pstr : PSTRRET; const pidl : PITEMIDLIST; var pbStr : TBSTR) : HResult; stdcall;

// helper to duplicate a string using the task allocator
function SHStrDupA(const psz : PAnsiChar; ppwsz : PPWideChar) : HResult; stdcall;
function SHStrDupW(const psz : PWideChar; ppwsz : PPWideChar) : HResult; stdcall;
function SHStrDup(const psz : PAnsiChar; ppwsz : PPWideChar) : HResult; stdcall;

function StrCmpLogicalW(const psz1, psz2 : PWideChar) : integer; stdcall;
function StrCatChainW(pszDst : PWideChar; cchDst, ichAt : cardinal; const pszSrc : PWideChar) : cardinal; stdcall;

function SHLoadIndirectString(const pszSource : PWideChar; pszOutBuf : PWideChar; cchOutBuf : cardinal; ppvReserved : PPointer) : HResult; stdcall;

function IsCharSpaceA(wch : AnsiChar) : bool; stdcall;
function IsCharSpaceW(wch : WideChar) : bool; stdcall;
function IsCharSpace(wch : AnsiChar) : bool; stdcall;

// Backward compatible to NT's non-standard naming (strictly
// for comctl32)
//
function IntlStrEqWorkerA(fCaseSens : bool; const lpString1, lpString2 : PAnsiChar; nChar : integer) : bool; stdcall;
function IntlStrEqWorkerW(fCaseSens : bool; const lpString1, lpString2 : PWideChar; nChar : integer) : bool; stdcall;
function IntlStrEqWorker(fCaseSens : bool; const lpString1, lpString2 : PAnsiChar; nChar : integer) : bool; stdcall;

function IntlStrEqNA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
function IntlStrEqNW(const s1, s2 : PWideChar; nChar : integer) : bool;
function IntlStrEqN(const s1, s2 : PAnsiChar; nChar : integer) : bool;
function IntlStrEqNIA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
function IntlStrEqNIW(const s1, s2 : PWideChar; nChar : integer) : bool;
function IntlStrEqNI(const s1, s2 : PAnsiChar; nChar : integer) : bool;

const
  SZ_CONTENTTYPE_HTML       = 'text/html';
  SZ_CONTENTTYPE_CDF        = 'application/x-cdf';

function PathIsHTMLFileA(const pszPath : PAnsiChar) : bool;
function PathIsHTMLFileW(const pszPath : PWideChar) : bool;
function PathIsHTMLFile(const pszPath : PAnsiChar) : bool;

// Flags for StrToIntEx
const
  STIF_DEFAULT        = $00000000;
  STIF_SUPPORT_HEX    = $00000001;

//
//=============== Path Routines ===================================
//

function PathAddBackslashA(pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathAddBackslashW(pszPath : PWideChar) : PWideChar; stdcall;
function PathAddBackslash(pszPath : PAnsiChar) : PAnsiChar; stdcall;

function PathAddExtensionA(pszPath : PAnsiChar; const pszExt : PAnsiChar) : bool; stdcall;
function PathAddExtensionW(pszPath : PWideChar; const pszExt : PWideChar) : bool; stdcall;
function PathAddExtension(pszPath : PAnsiChar; const pszExt : PAnsiChar) : bool; stdcall;

function PathAppendA(pszPath : PAnsiChar; const pMore : PAnsiChar) : bool; stdcall;
function PathAppendW(pszPath : PWideChar; const pMore : PWideChar) : bool; stdcall;
function PathAppend(pszPath : PAnsiChar; const pMore : PAnsiChar) : bool; stdcall;

function PathBuildRootA(pszRoot : PAnsiChar; iDrive : integer) : PAnsiChar; stdcall;
function PathBuildRootW(pszRoot : PWideChar; iDrive : integer) : PWideChar; stdcall;
function PathBuildRoot(pszRoot : PAnsiChar; iDrive : integer) : PAnsiChar; stdcall;

function PathCanonicalizeA(pszBuf : PAnsiChar; const pszPath : PAnsiChar) : bool; stdcall;
function PathCanonicalizeW(pszBuf : PWideChar; const pszPath : PWideChar) : bool; stdcall;
function PathCanonicalize(pszBuf : PAnsiChar; const pszPath : PAnsiChar) : bool; stdcall;

function PathCombineA(pszDest : PAnsiChar; const pszDir, pszFile : PAnsiChar) : PAnsiChar; stdcall;
function PathCombineW(pszDest : PWideChar; const pszDir, pszFile : PWideChar) : PWideChar; stdcall;
function PathCombine(pszDest : PAnsiChar; const pszDir, pszFile : PAnsiChar) : PAnsiChar; stdcall;

function PathCompactPathA(dc : HDC; pszPath : PAnsiChar; dx : cardinal) : bool; stdcall;
function PathCompactPathW(dc : HDC; pszPath : PWideChar; dx : cardinal) : bool; stdcall;
function PathCompactPath(dc : HDC; pszPath : PAnsiChar; dx : cardinal) : bool; stdcall;

function PathCompactPathExA(pszOut : PAnsiChar; pszSrc : PAnsiChar; cchMax : cardinal; dwFlags : cardinal) : bool; stdcall;
function PathCompactPathExW(pszOut : PWideChar; pszSrc : PWideChar; cchMax : cardinal; dwFlags : cardinal) : bool; stdcall;
function PathCompactPathEx(pszOut : PAnsiChar; pszSrc : PAnsiChar; cchMax : cardinal; dwFlags : cardinal) : bool; stdcall;

function PathCommonPrefixA(const pszFile1, pszFile2 : PAnsiChar; achPath : PAnsiChar) : integer; stdcall;
function PathCommonPrefixW(const pszFile1, pszFile2 : PWideChar; achPath : PWideChar) : integer; stdcall;
function PathCommonPrefix(const pszFile1, pszFile2 : PAnsiChar; achPath : PAnsiChar) : integer; stdcall;

function PathFileExistsA(const pszPath : PAnsiChar) : bool; stdcall;
function PathFileExistsW(const pszPath : PWideChar) : bool; stdcall;
function PathFileExists(const pszPath : PAnsiChar) : bool; stdcall;

function PathFindExtensionA(const pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathFindExtensionW(const pszPath : PWideChar) : PWideChar; stdcall;
function PathFindExtension(const pszPath : PAnsiChar) : PAnsiChar; stdcall;

function PathFindFileNameA(const pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathFindFileNameW(const pszPath : PWideChar) : PWideChar; stdcall;
function PathFindFileName(const pszPath : PAnsiChar) : PAnsiChar; stdcall;

function PathFindNextComponentA(const pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathFindNextComponentW(const pszPath : PWideChar) : PWideChar; stdcall;
function PathFindNextComponent(const pszPath : PAnsiChar) : PAnsiChar; stdcall;

function PathFindOnPathA(pszPath : PAnsiChar; ppszOtherDirs : PPAnsiChar) : bool; stdcall;
function PathFindOnPathW(pszPath : PWideChar; ppszOtherDirs : PPWideChar) : bool; stdcall;
function PathFindOnPath(pszPath : PAnsiChar; ppszOtherDirs : PPAnsiChar) : bool; stdcall;

function PathGetArgsA(const pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathGetArgsW(const pszPath : PWideChar) : PWideChar; stdcall;
function PathGetArgs(const pszPath : PAnsiChar) : PAnsiChar; stdcall;

function PathFindSuffixArrayA(const pszPath : PAnsiChar; apszSuffix : PPAnsiChar; iArraySize : integer) : bool; stdcall;
function PathFindSuffixArrayW(const pszPath : PWideChar; apszSuffix : PPWideChar; iArraySize : integer) : bool; stdcall;
function PathFindSuffixArray(const pszPath : PAnsiChar; apszSuffix : PPAnsiChar; iArraySize : integer) : bool; stdcall;

function PathIsLFNFileSpecA(const lpName : PAnsiChar) : bool; stdcall;
function PathIsLFNFileSpecW(const lpName : PWideChar) : bool; stdcall;
function PathIsLFNFileSpec(const lpName : PAnsiChar) : bool; stdcall;

function PathGetCharTypeA(ch : AnsiChar) : cardinal; stdcall;
function PathGetCharTypeW(ch : WideChar) : cardinal; stdcall;
function PathGetCharType(ch : AnsiChar) : cardinal; stdcall;

// Return flags for PathGetCharType
const
  GCT_INVALID   = $0000;
  GCT_LFNCHAR   = $0001;
  GCT_SHORTCHAR = $0002;
  GCT_WILD      = $0004;
  GCT_SEPARATOR = $0008;

function PathGetDriveNumberA(const pszPath : PAnsiChar) : integer; stdcall;
function PathGetDriveNumberW(const pszPath : PWideChar) : integer; stdcall;
function PathGetDriveNumber(const pszPath : PAnsiChar) : integer; stdcall;

function PathIsDirectoryA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsDirectoryW(const pszPath : PWideChar) : bool; stdcall;
function PathIsDirectory(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsDirectoryEmptyA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsDirectoryEmptyW(const pszPath : PWideChar) : bool; stdcall;
function PathIsDirectoryEmpty(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsFileSpecA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsFileSpecW(const pszPath : PWideChar) : bool; stdcall;
function PathIsFileSpec(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsPrefixA(const pszPrefix, pszPath : PAnsiChar) : bool; stdcall;
function PathIsPrefixW(const pszPrefix, pszPath : PWideChar) : bool; stdcall;
function PathIsPrefix(const pszPrefix, pszPath : PAnsiChar) : bool; stdcall;

function PathIsRelativeA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsRelativeW(const pszPath : PWideChar) : bool; stdcall;
function PathIsRelative(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsRootA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsRootW(const pszPath : PWideChar) : bool; stdcall;
function PathIsRoot(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsSameRootA(const pszPath1, pszPath2 : PAnsiChar) : bool; stdcall;
function PathIsSameRootW(const pszPath1, pszPath2 : PWideChar) : bool; stdcall;
function PathIsSameRoot(const pszPath1, pszPath2 : PAnsiChar) : bool; stdcall;

function PathIsUNCA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsUNCW(const pszPath : PWideChar) : bool; stdcall;
function PathIsUNC(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsNetworkPathA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsNetworkPathW(const pszPath : PWideChar) : bool; stdcall;
function PathIsNetworkPath(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsUNCServerA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsUNCServerW(const pszPath : PWideChar) : bool; stdcall;
function PathIsUNCServer(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsUNCServerShareA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsUNCServerShareW(const pszPath : PWideChar) : bool; stdcall;
function PathIsUNCServerShare(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsContentTypeA(const pszPath, pszContentType : PAnsiChar) : bool; stdcall;
function PathIsContentTypeW(const pszPath, pszContentType : PWideChar) : bool; stdcall;
function PathIsContentType(const pszPath, pszContentType : PAnsiChar) : bool; stdcall;

function PathIsURLA(const pszPath : PAnsiChar) : bool; stdcall;
function PathIsURLW(const pszPath : PWideChar) : bool; stdcall;
function PathIsURL(const pszPath : PAnsiChar) : bool; stdcall;

function PathMakePrettyA(pszPath : PAnsiChar) : bool; stdcall;
function PathMakePrettyW(pszPath : PWideChar) : bool; stdcall;
function PathMakePretty(pszPath : PAnsiChar) : bool; stdcall;

function PathMatchSpecA(const pszFile, pszSpec : PAnsiChar) : bool; stdcall;
function PathMatchSpecW(const pszFile, pszSpec : PWideChar) : bool; stdcall;
function PathMatchSpec(const pszFile, pszSpec : PAnsiChar) : bool; stdcall;

function PathParseIconLocationA(pszIconFile : PAnsiChar) : integer; stdcall;
function PathParseIconLocationW(pszIconFile : PWideChar) : integer; stdcall;
function PathParseIconLocation(pszIconFile : PAnsiChar) : integer; stdcall;

procedure PathQuoteSpacesA(lpsz : PAnsiChar); stdcall;
procedure PathQuoteSpacesW(lpsz : PWideChar); stdcall;
procedure PathQuoteSpaces(lpsz : PAnsiChar); stdcall;

function PathRelativePathToA(pszPath : PAnsiChar; const pszFrom : PAnsiChar; dwAttrFrom : cardinal; const pszTo : PAnsiChar; dwAttrTo : cardinal) : bool; stdcall;
function PathRelativePathToW(pszPath : PWideChar; const pszFrom : PWideChar; dwAttrFrom : cardinal; const pszTo : PWideChar; dwAttrTo : cardinal) : bool; stdcall;
function PathRelativePathTo(pszPath : PAnsiChar; const pszFrom : PAnsiChar; dwAttrFrom : cardinal; const pszTo : PAnsiChar; dwAttrTo : cardinal) : bool; stdcall;

procedure PathRemoveArgsA(pszPath : PAnsiChar); stdcall;
procedure PathRemoveArgsW(pszPath : PWideChar); stdcall;
procedure PathRemoveArgs(pszPath : PAnsiChar); stdcall;

function PathRemoveBackslashA(pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathRemoveBackslashW(pszPath : PWideChar) : PWideChar; stdcall;
function PathRemoveBackslash(pszPath : PAnsiChar) : PAnsiChar; stdcall;

procedure PathRemoveBlanksA(pszPath : PAnsiChar); stdcall;
procedure PathRemoveBlanksW(pszPath : PWideChar); stdcall;
procedure PathRemoveBlanks(pszPath : PAnsiChar); stdcall;

procedure PathRemoveExtensionA(pszPath : PAnsiChar); stdcall;
procedure PathRemoveExtensionW(pszPath : PWideChar); stdcall;
procedure PathRemoveExtension(pszPath : PAnsiChar); stdcall;

function PathRemoveFileSpecA(pszPath : PAnsiChar) : bool; stdcall;
function PathRemoveFileSpecW(pszPath : PWideChar) : bool; stdcall;
function PathRemoveFileSpec(pszPath : PAnsiChar) : bool; stdcall;

function PathRenameExtensionA(pszPath : PAnsiChar; const pszExt : PAnsiChar) : bool; stdcall;
function PathRenameExtensionW(pszPath : PWideChar; const pszExt : PWideChar) : bool; stdcall;
function PathRenameExtension(pszPath : PAnsiChar; const pszExt : PAnsiChar) : bool; stdcall;

function PathSearchAndQualifyA(const pszPath : PAnsiChar; pszBuf : PAnsiChar; cchBuf : cardinal) : bool; stdcall;
function PathSearchAndQualifyW(const pszPath : PWideChar; pszBuf : PWideChar; cchBuf : cardinal) : bool; stdcall;
function PathSearchAndQualify(const pszPath : PAnsiChar; pszBuf : PAnsiChar; cchBuf : cardinal) : bool; stdcall;

procedure PathSetDlgItemPathA(hDlg : HWND; id : integer; const pszPath : PAnsiChar); stdcall;
procedure PathSetDlgItemPathW(hDlg : HWND; id : integer; const pszPath : PWideChar); stdcall;
procedure PathSetDlgItemPath(hDlg : HWND; id : integer; const pszPath : PAnsiChar); stdcall;

function PathSkipRootA(const pszPath : PAnsiChar) : PAnsiChar; stdcall;
function PathSkipRootW(const pszPath : PWideChar) : PWideChar; stdcall;
function PathSkipRoot(const pszPath : PAnsiChar) : PAnsiChar; stdcall;

procedure PathStripPathA(pszPath : PAnsiChar); stdcall;
procedure PathStripPathW(pszPath : PWideChar); stdcall;
procedure PathStripPath(pszPath : PAnsiChar); stdcall;

function PathStripToRootA(pszPath : PAnsiChar) : bool; stdcall;
function PathStripToRootW(pszPath : PWideChar) : bool; stdcall;
function PathStripToRoot(pszPath : PAnsiChar) : bool; stdcall;

procedure PathUnquoteSpacesA(lpsz : PAnsiChar); stdcall;
procedure PathUnquoteSpacesW(lpsz : PWideChar); stdcall;
procedure PathUnquoteSpaces(lpsz : PAnsiChar); stdcall;

function PathMakeSystemFolderA(const pszPath : PAnsiChar) : bool; stdcall;
function PathMakeSystemFolderW(const pszPath : PWideChar) : bool; stdcall;
function PathMakeSystemFolder(const pszPath : PAnsiChar) : bool; stdcall;

function PathUnmakeSystemFolderA(const pszPath : PAnsiChar) : bool; stdcall;
function PathUnmakeSystemFolderW(const pszPath : PWideChar) : bool; stdcall;
function PathUnmakeSystemFolder(const pszPath : PAnsiChar) : bool; stdcall;

function PathIsSystemFolderA(const pszPath : PAnsiChar; dwAttrb : cardinal) : bool; stdcall;
function PathIsSystemFolderW(const pszPath : PWideChar; dwAttrb : cardinal) : bool; stdcall;
function PathIsSystemFolder(const pszPath : PAnsiChar; dwAttrb : cardinal) : bool; stdcall;

procedure PathUndecorateA(pszPath : PAnsiChar); stdcall;
procedure PathUndecorateW(pszPath : PWideChar); stdcall;
procedure PathUndecorate(pszPath : PAnsiChar); stdcall;

function PathUnExpandEnvStringsA(const pszPath : PAnsiChar; pszBuf : PAnsiChar; cchBuf : cardinal) : bool; stdcall;
function PathUnExpandEnvStringsW(const pszPath : PWideChar; pszBuf : PWideChar; cchBuf : cardinal) : bool; stdcall;
function PathUnExpandEnvStrings(const pszPath : PAnsiChar; pszBuf : PAnsiChar; cchBuf : cardinal) : bool; stdcall;

const
  URL_SCHEME_INVALID     = -1;
  URL_SCHEME_UNKNOWN     =  0;
  URL_SCHEME_FTP         =  1;
  URL_SCHEME_HTTP        =  2;
  URL_SCHEME_GOPHER      =  3;
  URL_SCHEME_MAILTO      =  4;
  URL_SCHEME_NEWS        =  5;
  URL_SCHEME_NNTP        =  6;
  URL_SCHEME_TELNET      =  7;
  URL_SCHEME_WAIS        =  8;
  URL_SCHEME_FILE        =  9;
  URL_SCHEME_MK          = 10;
  URL_SCHEME_HTTPS       = 11;
  URL_SCHEME_SHELL       = 12;
  URL_SCHEME_SNEWS       = 13;
  URL_SCHEME_LOCAL       = 14;
  URL_SCHEME_JAVASCRIPT  = 15;
  URL_SCHEME_VBSCRIPT    = 16;
  URL_SCHEME_ABOUT       = 17;
  URL_SCHEME_RES         = 18;
  URL_SCHEME_MSSHELLROOTED = 19;
  URL_SCHEME_MSSHELLIDLIST = 20;
  URL_SCHEME_MSHELP        = 21;
  URL_SCHEME_MAXVALUE      = 22;

type
  URL_SCHEME = integer;

const
  URL_PART_NONE       = 0;
  URL_PART_SCHEME     = 1;
  URL_PART_HOSTNAME   = 2;
  URL_PART_USERNAME   = 3;
  URL_PART_PASSWORD   = 4;
  URL_PART_PORT       = 5;
  URL_PART_QUERY      = 6;

type
  URL_PART = cardinal;

const
  URLIS_URL = 0;
  URLIS_OPAQUE = 1;
  URLIS_NOHISTORY = 2;
  URLIS_FILEURL = 3;
  URLIS_APPLIABLE = 4;
  URLIS_DIRECTORY = 5;
  URLIS_HASQUERY = 6;

type
  TURLIS = cardinal;

const
  URL_UNESCAPE                    = $10000000;
  URL_ESCAPE_UNSAFE               = $20000000;
  URL_PLUGGABLE_PROTOCOL          = $40000000;
  URL_WININET_COMPATIBILITY       = $80000000;
  URL_DONT_ESCAPE_EXTRA_INFO      = $02000000;
  URL_DONT_UNESCAPE_EXTRA_INFO    = URL_DONT_ESCAPE_EXTRA_INFO;
  URL_BROWSER_MODE                = URL_DONT_ESCAPE_EXTRA_INFO;
  URL_ESCAPE_SPACES_ONLY          = $04000000;
  URL_DONT_SIMPLIFY               = $08000000;
  URL_NO_META                     = URL_DONT_SIMPLIFY;
  URL_UNESCAPE_INPLACE            = $00100000;
  URL_CONVERT_IF_DOSPATH          = $00200000;
  URL_UNESCAPE_HIGH_ANSI_ONLY     = $00400000;
  URL_INTERNAL_PATH               = $00800000;  // Will escape #'s in paths
  URL_FILE_USE_PATHURL            = $00010000;
  URL_DONT_UNESCAPE               = $00020000;  // Do not unescape the path/url at all
  URL_ESCAPE_PERCENT              = $00001000;
  URL_ESCAPE_SEGMENT_ONLY         = $00002000;  // Treat the entire URL param as one URL segment.

  URL_PARTFLAG_KEEPSCHEME         = $00000001;

  URL_APPLY_DEFAULT               = $00000001;
  URL_APPLY_GUESSSCHEME           = $00000002;
  URL_APPLY_GUESSFILE             = $00000004;
  URL_APPLY_FORCEAPPLY            = $00000008;

function UrlCompareA(const psz1, psz2 : PAnsiChar; fIgnoreSlash : bool) : integer; stdcall;
function UrlCompareW(const psz1, psz2 : PWideChar; fIgnoreSlash : bool) : integer; stdcall;
function UrlCompare(const psz1, psz2 : PAnsiChar; fIgnoreSlash : bool) : integer; stdcall;

function UrlCombineA(const pszBase, pszRelative : PAnsiChar; pszCombined : PAnsiChar; var pcchCombined : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCombineW(const pszBase, pszRelative : PWideChar; pszCombined : PWideChar; var pcchCombined : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCombine(const pszBase, pszRelative : PAnsiChar; pszCombined : PAnsiChar; var pcchCombined : cardinal; dwFlags : cardinal) : hResult; stdcall;

function UrlCanonicalizeA(const pszUrl : PAnsiChar; pszCanonicalized : PAnsiChar; var pcchCanonicalized : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCanonicalizeW(const pszUrl : PWideChar; pszCanonicalized : PWideChar; var pcchCanonicalized : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCanonicalize(const pszUrl : PAnsiChar; pszCanonicalized : PAnsiChar; var pcchCanonicalized : cardinal; dwFlags : cardinal) : hResult; stdcall;

function UrlIsOpaqueA(const pszURL : PAnsiChar) : bool; stdcall;
function UrlIsOpaqueW(const pszURL : PWideChar) : bool; stdcall;
function UrlIsOpaque(const pszURL : PAnsiChar) : bool; stdcall;

function UrlIsNoHistoryA(const pszURL : PAnsiChar) : bool; stdcall;
function UrlIsNoHistoryW(const pszURL : PWideChar) : bool; stdcall;
function UrlIsNoHistory(const pszURL : PAnsiChar) : bool; stdcall;

function UrlIsA(const pszUrl : PAnsiChar; UrlIs : TURLIS) : bool; stdcall;
function UrlIsW(const pszUrl : PWideChar; UrlIs : TURLIS) : bool; stdcall;
function UrlIs(const pszUrl : PAnsiChar; UrlIs : TURLIS) : bool; stdcall;

function UrlIsFileUrlA(pszURL : PAnsiChar) : bool;
function UrlIsFileUrlW(pszURL : PWideChar) : bool;
function UrlIsFileUrl(pszURL : PAnsiChar) : bool;

function UrlGetLocationA(const psz1 : PAnsiChar) : PAnsiChar; stdcall;
function UrlGetLocationW(const psz1 : PWideChar) : PWideChar; stdcall;
function UrlGetLocation(const psz1 : PAnsiChar) : PAnsiChar; stdcall;

function UrlUnescapeA(pszUrl, pszUnescaped : PAnsiChar; var pcchUnescaped : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlUnescapeW(pszUrl, pszUnescaped : PWideChar; var pcchUnescaped : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlUnescape(pszUrl, pszUnescaped : PAnsiChar; var pcchUnescaped : cardinal; dwFlags : cardinal) : hResult; stdcall;

function UrlEscapeA(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; var pcchEscaped : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlEscapeW(const pszUrl : PWideChar; pszEscaped : PWideChar; var pcchEscaped : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlEscape(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; var pcchEscaped : cardinal; dwFlags : cardinal) : hResult; stdcall;

function UrlCreateFromPathA(const pszPath : PAnsiChar; pszUrl : PAnsiChar; var pcchUrl : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCreateFromPathW(const pszPath : PWideChar; pszUrl : PWideChar; var pcchUrl : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlCreateFromPath(const pszPath : PAnsiChar; pszUrl : PAnsiChar; var pcchUrl : cardinal; dwFlags : cardinal) : hResult; stdcall;

function PathCreateFromUrlA(const pszUrl : PAnsiChar; pszPath : PAnsiChar; var pcchPath : cardinal; dwFlags : cardinal) : hResult; stdcall;
function PathCreateFromUrlW(const pszUrl : PWideChar; pszPath : PWideChar; var pcchPath : cardinal; dwFlags : cardinal) : hResult; stdcall;
function PathCreateFromUrl(const pszUrl : PAnsiChar; pszPath : PAnsiChar; var pcchPath : cardinal; dwFlags : cardinal) : hResult; stdcall;

function UrlHashA(const pszUrl : PAnsiChar; pbHash : PByte; cbHash : cardinal) : hResult; stdcall;
function UrlHashW(const pszUrl : PWideChar; pbHash : PByte; cbHash : cardinal) : hResult; stdcall;
function UrlHash(const pszUrl : PAnsiChar; pbHash : PByte; cbHash : cardinal) : hResult; stdcall;

function UrlGetPartA(const pszIn : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal; dwPart, dwFlags : cardinal) : hResult; stdcall;
function UrlGetPartW(const pszIn : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal; dwPart, dwFlags : cardinal) : hResult; stdcall;
function UrlGetPart(const pszIn : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal; dwPart, dwFlags : cardinal) : hResult; stdcall;

function UrlApplySchemeA(const pszIn : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlApplySchemeW(const pszIn : PWideChar; pszOut : PWideChar; var pcchOut : cardinal; dwFlags : cardinal) : hResult; stdcall;
function UrlApplyScheme(const pszIn : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal; dwFlags : cardinal) : hResult; stdcall;

function HashData(pbData : PByte; cbData : cardinal; pbHash : PByte; cbHash : cardinal) : hResult; stdcall;

function UrlEscapeSpacesA(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; pcchEscaped : cardinal): HResult;
function UrlEscapeSpacesW(const pszUrl : PWideChar; pszEscaped : PWideChar; pcchEscaped : cardinal): HResult;
function UrlEscapeSpaces(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; pcchEscaped : cardinal): HResult;

function UrlUnescapeInPlaceA(pszUrl : PAnsiChar; dwFlags : cardinal) : HResult;
function UrlUnescapeInPlaceW(pszUrl : PWideChar; dwFlags : cardinal) : HResult;
function UrlUnescapeInPlace(pszUrl : PAnsiChar; dwFlags : cardinal) : HResult;

//
//=============== Registry Routines ===================================
//

// SHDeleteEmptyKey mimics RegDeleteKey as it behaves on NT.
// SHDeleteKey mimics RegDeleteKey as it behaves on Win95.

function SHDeleteEmptyKeyA(key : HKEY; const pszSubKey : PAnsiChar) : cardinal; stdcall;
function SHDeleteEmptyKeyW(key : HKEY; const pszSubKey : PWideChar) : cardinal; stdcall;
function SHDeleteEmptyKey(key : HKEY; const pszSubKey : PAnsiChar) : cardinal; stdcall;

function SHDeleteKeyA(key : HKey; const pszSubKey : PAnsiChar) : cardinal; stdcall;
function SHDeleteKeyW(key : HKey; const pszSubKey : PWideChar) : cardinal; stdcall;
function SHDeleteKey(key : HKey; const pszSubKey : PAnsiChar) : cardinal; stdcall;

function SHRegDuplicateHKey(key : HKEY) : HKEY; stdcall;

// These functions open the key, get/set/delete the value, then close
// the key.
function SHDeleteValueA(key : HKEY; const pszSubKey, pszValue : PAnsiChar) : cardinal; stdcall;
function SHDeleteValueW(key : HKEY; const pszSubKey, pszValue : PWideChar) : cardinal; stdcall;
function SHDeleteValue(key : HKEY; const pszSubKey, pszValue : PAnsiChar) : cardinal; stdcall;

function SHGetValueA(key : HKEY; const pszSubKey, pszValue : PAnsiChar; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;
function SHGetValueW(key : HKEY; const pszSubKey, pszValue : PWideChar; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;
function SHGetValue(key : HKEY; const pszSubKey, pszValue : PAnsiChar; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;

function SHSetValueA(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwType : cardinal; const pvData : pointer; cbData : cardinal) : cardinal; stdcall;
function SHSetValueW(key : HKEY; const pszSubKey, pszValue : PWideChar; dwType : cardinal; const pvData : pointer; cbData : cardinal) : cardinal; stdcall;
function SHSetValue(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwType : cardinal; const pvData : pointer; cbData : cardinal) : cardinal; stdcall;

//
// SRRF - Shell Registry Routine Flags (for SHRegGetValue)
//

type
  SRRF = cardinal;

const
  SRRF_RT_REG_NONE        = $00000001;  // restrict type to REG_NONE      (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_SZ          = $00000002;  // restrict type to REG_SZ        (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_EXPAND_SZ   = $00000004;  // restrict type to REG_EXPAND_SZ (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_BINARY      = $00000008;  // restrict type to REG_BINARY    (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_DWORD       = $00000010;  // restrict type to REG_DWORD     (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_MULTI_SZ    = $00000020;  // restrict type to REG_MULTI_SZ  (other data types will not return ERROR_SUCCESS)
  SRRF_RT_REG_QWORD       = $00000040;  // restrict type to REG_QWORD     (other data types will not return ERROR_SUCCESS)

  SRRF_RT_DWORD           = (SRRF_RT_REG_BINARY or SRRF_RT_REG_DWORD); // restrict type to *32-bit* SRRF_RT_REG_BINARY or SRRF_RT_REG_DWORD (other data types will not return ERROR_SUCCESS)
  SRRF_RT_QWORD           = (SRRF_RT_REG_BINARY or SRRF_RT_REG_QWORD); // restrict type to *64-bit* SRRF_RT_REG_BINARY or SRRF_RT_REG_DWORD (other data types will not return ERROR_SUCCESS)
  SRRF_RT_ANY             = $0000ffff;                                 // no type restriction

  SRRF_RM_ANY             = $00000000;  // no mode restriction (default is to allow any mode)
  SRRF_RM_NORMAL          = $00010000;  // restrict system startup mode to "normal boot"               (other startup modes will not return ERROR_SUCCESS)
  SRRF_RM_SAFE            = $00020000;  // restrict system startup mode to "safe mode"                 (other startup modes will not return ERROR_SUCCESS)
  SRRF_RM_SAFENETWORK     = $00040000;  // restrict system startup mode to "safe mode with networking" (other startup modes will not return ERROR_SUCCESS)

  SRRF_NOEXPAND           = $10000000;  // do not automatically expand environment strings if value is of type REG_EXPAND_SZ
  SRRF_ZEROONFAILURE      = $20000000;  // if pvData is not NULL, set content to all zeros on failure

// Function:
//
//  SHRegGetValue()
//
// Purpose:
//
//  Gets a registry value.  SHRegGetValue() provides the following benefits:
//
//  - data type checking
//  - boot mode checking
//  - auto-expansion of REG_EXPAND_SZ data
//  - guaranteed NULL termination of REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ data
//
// Parameters:
//
//  hkey        - handle to a currently open key.
//
//  pszSubKey   - pointer to a null-terminated string specifying the relative
//                path from hkey to one of its subkeys from which the data is
//                to be retrieved.  this will be opened with KEY_READ sam.
//
//                Note1: pszSubKey can be NULL or "".  In either of these two
//                       cases, the data is retrieved from the hkey itself.
//                Note2: *** PERF ***
//                       If pszSubKey is not NULL or "", the subkey will be
//                       automatically be opened and closed by this routine
//                       in order to obtain the data.  If you are retrieving
//                       multiple values from the same subkey, it is better
//                       for perf to open the subkey via RegOpenKeyEx() prior
//                       to calling this method, and using this opened key as
//                       hkey with pszSubKey set to NULL.
//
//  pszValue    - pointer to a null-terminated string specifying the name of
//                the value to query for data
//
//                Note1: pszValue can be NULL or "".  In either of these two
//                       cases, the data is retrieved from the unnamed or
//                       default value.
//
//  dwFlags     - bitwise or of SRRF_ flags, which cannot be 0:  at least one
//                type restriction must be specified (SRRF_RT_...), or if any
//                type is desired then SRRF_RT_ANY can be specified
//
//                Note1: SRRF_RT_ANY will allow any data type to be returned.
//                Note2: The following two type restrictions have special
//                       handling semantics:
//
//                         SRRF_RT_DWORD == SRRF_RT_REG_BINARY | SRRF_RT_REG_DWORD
//                         SRRF_RT_QWORD == SRRF_RT_REG_BINARY | SRRF_RT_REG_QWORD
//
//                       If either of these are specified, with no other type
//                       restrictions, then in the prior case the restriction
//                       will limit "valid" returned data to either REG_DWORD
//                       or 32-bit REG_BINARY data, and in the latter case
//                       the restriction will limit "valid" returned data to
//                       either REG_QWORD or 64-bit REG_BINARY.
//
//  pdwType     - pointer to a dword which receives a code indicating the
//                type of data stored in the specified value
//
//                Note1: pdwType can be NULL if no type information is wanted
//                Note2: If pdwType is not NULL, and the SRRF_NOEXPAND flag
//                       has not been set, data types of REG_EXPAND_SZ will
//                       be returned as REG_SZ since they are automatically
//                       expanded in this method.
//
//  pvData      - pointer to a buffer that receives the value's data
//
//                Note1: pvData can be NULL if the data is not required.
//                       pvData is usually NULL if doing either a simple
//                       existence test, or if interested in the size only.
//                Note2: *** PERF ***
//                       Reference 'perf' note for pcbData.
//
//  pcbData     - when pvData is NULL:
//                  optional pointer to a dword that receives a size in bytes
//                  which would be sufficient to hold the registry data (note
//                  this size is not guaranteed to be exact, merely sufficient)
//                when pvData is not NULL:
//                  required pointer to a dword that specifies the size in
//                  bytes of the buffer pointed to by the pvData parameter
//                  and receives a size in bytes of:
//                  a) the number of bytes read into pvData on ERROR_SUCCESS
//                     (note this size is guaranteed to be exact)
//                  b) the number of bytes which would be sufficient to hold
//                     the registry data on ERROR_MORE_DATA -- pvData was of
//                     insufficient size (note this size is not guaranteed to
//                     be exact, merely sufficient)
//
//                Note1: pcbData can be NULL only if pvData is NULL.
//                Note2: *** PERF ***
//                       The potential for an 'extra' call to the registry to
//                       read (or re-read) in the data exists when the data
//                       type is REG_EXPAND_SZ and the SRRF_NOEXPAND flag has
//                       not been set.  The following conditions will result
//                       in this 'extra' read operation:
//                       i)  when pvData is NULL and pcbData is not NULL
//                           we must read in the data from the registry
//                           anyway in order to obtain the string and perform
//                           an expand on it to obtain and return the total
//                           required size in pcbData
//                       ii) when pvData is not NULL but is of insufficient
//                           size we must re-read in the data from the
//                           registry in order to obtain the entire string
//                           and perform an expand on it to obtain and return
//                           the total required size in pcbData
//
// Remarks:
//
//  The key identified by hkey must have been opened with KEY_QUERY_VALUE
//  access.  If pszSubKey is not NULL or "", it must be able to be opened
//  with KEY_QUERY_VALUE access in the current calling context.
//
//  If the data type is REG_SZ, REG_EXPAND_SZ or REG_MULTI_SZ then any
//  returned data is guaranteed to take into account proper null termination.
//  For example:  if pcbData is not NULL, its returned size will include the
//  bytes for a null terminator  if pvData is not NULL, its returned data
//  will be properly null terminated.
//
//  If the data type is REG_EXPAND_SZ, then unless the SRRF_NOEXPAND flag
//  is set the data will be automatically expanded prior to being returned.
//  For example:  if pdwType is not NULL, its returned type will be changed
//  to REG_SZ,  if pcbData is not NULL, its returned size will include the
//  bytes for a properly expanded string.  if pvData is not NULL, its
//  returned data will be the expanded version of the string.
//
//  Reference MSDN documentation for RegQueryValueEx() for more information
//  of the behaviour when pdwType, pvData, and/or pcbData are equal to NULL.
//
// Return Values:
//
//  If the function succeeds, the return value is ERROR_SUCCESS and all out
//  parameters requested (pdwType, pvData, pcbData) are valid.
//
//  If the function fails due to insufficient space in a provided non-NULL
//  pvData, the return value is ERROR_MORE_DATA and only pdwType and pcbData
//  can contain valid data.  The content of pvData in this case is undefined.
//
// Examples:
//
//  1) read REG_SZ (or REG_EXPAND_SZ as REG_SZ) "string" data from the (default) value of an open hkey
//
//      TCHAR szData[128]
//      DWORD cbData = sizeof(pszData)
//      if (ERROR_SUCCESS == SHRegGetValue(hkey, NULL, NULL, SRRF_RT_REG_SZ, NULL, szData, &cbData))
//      {
//          // use sz (successful read)
//      }
//
//  2) read REG_SZ (or REG_EXPAND_SZ as REG_SZ) "string" data of unknown size from the "MyValue" value of an open hkey
//
//      DWORD cbData
//      if (ERROR_SUCCESS == SHRegGetValue(hkey, NULL, TEXT("MyValue"), SRRF_RT_REG_SZ, NULL, NULL, &cbData))
//      {
//          TCHAR *pszData = new TCHAR[cbData/sizeof(TCHAR)]
//          if (pszData)
//          {
//              if (ERROR_SUCCESS == SHRegGetValue(hkey, NULL, TEXT("MyValue"), SRRF_RT_REG_SZ, NULL, pszData, &cbData))
//              {
//                  // use pszData (successful read)
//              }
//              delete[] pszData
//          }
//      }
//
//  3) read "dword" data from the "MyValue" value of the "MySubKey" subkey of an open hkey
//
//      DWORD dwData
//      DWORD cbData = sizeof(dwData)
//      if (ERROR_SUCCESS == SHRegGetValue(hkey, TEXT("MySubKey"), TEXT("MyValue"), SRRF_RT_REG_DWORD, NULL, &dwData, &cbData))
//      {
//          // use dwData (successful read)
//      }
//
//  4) read "dword" data from the "MyValue" value of the "MySubKey" subkey of an open hkey (32-bit binary data also ok)
//
//      DWORD dwData
//      DWORD cbData = sizeof(dwData)
//      if (ERROR_SUCCESS == SHRegGetValue(hkey, TEXT("MySubKey"), TEXT("MyValue"), SRRF_RT_DWORD, NULL, &dwData, &cbData))
//      {
//          // use dwData (successful read)
//      }
//
//  5) determine existence of "MyValue" value of an open hkey
//
//      BOOL bExists = ERROR_SUCCESS == SHRegGetValue(hkey, NULL, TEXT("MyValue"), SRRF_RT_ANY, NULL, NULL, NULL)

function SHRegGetValueA(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
function SHRegGetValueW(key : HKEY; const pszSubKey, pszValue : PWideChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
function SHRegGetValue(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;

// These functions behave just like RegQueryValueEx(), except if the data
// type is REG_SZ, REG_EXPAND_SZ or REG_MULTI_SZ then the string is
// guaranteed to be properly null terminated.
//
// Additionally, if the data type is REG_EXPAND_SZ these functions will
// go ahead and expand out the string, and "massage" the returned *pdwType
// to be REG_SZ.

function SHQueryValueExA(key : HKey; pszValue : PAnsiChar; var pdwReserved, pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;
function SHQueryValueExW(key : HKey; pszValue : PWideChar; var pdwReserved, pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;
function SHQueryValueEx(key : HKey; pszValue : PAnsiChar; var pdwReserved, pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : cardinal; stdcall;

// Enumeration functions support.

function SHEnumKeyExA(key : HKey; dwIndex : cardinal; pszName : PAnsiChar; var pcchName : cardinal) : integer; stdcall;
function SHEnumKeyExW(key : HKey; dwIndex : cardinal; pszName : PWideChar; var pcchName : cardinal) : integer; stdcall;
function SHEnumKeyEx(key : HKey; dwIndex : cardinal; pszName : PAnsiChar; var pcchName : cardinal) : integer; stdcall;

function SHEnumValueA(key : HKey; dwIndex : cardinal; pszValueName : PAnsiChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
function SHEnumValueW(key : HKey; dwIndex : cardinal; pszValueName : PWideChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
function SHEnumValue(key : HKey; dwIndex : cardinal; pszValueName : PAnsiChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;

function SHQueryInfoKeyA(key : HKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal) : integer; stdcall;
function SHQueryInfoKeyW(key : HKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal) : integer; stdcall;
function SHQueryInfoKey(key : HKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal) : integer; stdcall;

// recursive key copy
function SHCopyKeyA(hKeySrc : HKEY; const szSrcSubKey : PAnsiChar; hkeyDest : HKey; fReserved : cardinal) : cardinal; stdcall;
function SHCopyKeyw(hKeySrc : HKEY; const szSrcSubKey : PWideChar; hkeyDest : HKey; fReserved : cardinal) : cardinal; stdcall;
function SHCopyKey(hKeySrc : HKEY; const szSrcSubKey : PAnsiChar; hkeyDest : HKey; fReserved : cardinal) : cardinal; stdcall;

// Getting and setting file system paths with environment variables

function SHRegGetPathA(Key : HKEY; const pcszSubKey, pcszValue : PAnsiChar; pszPath : PAnsiChar; dwFlags : cardinal) : cardinal; stdcall;
function SHRegGetPathW(Key : HKEY; const pcszSubKey, pcszValue : PWideChar; pszPath : PWideChar; dwFlags : cardinal) : cardinal; stdcall;
function SHRegGetPath(Key : HKEY; const pcszSubKey, pcszValue : PAnsiChar; pszPath : PAnsiChar; dwFlags : cardinal) : cardinal; stdcall;

function SHRegSetPathA(key : HKEY; const pcszSubKey, pcszValue, pcszPath : PAnsiChar; dwFlags : cardinal) : cardinal; stdcall;
function SHRegSetPathW(key : HKEY; const pcszSubKey, pcszValue, pcszPath : PWideChar; dwFlags : cardinal) : cardinal; stdcall;
function SHRegSetPath(key : HKEY; const pcszSubKey, pcszValue, pcszPath : PAnsiChar; dwFlags : cardinal) : cardinal; stdcall;

//////////////////////////////////////////////
// User Specific Registry Access Functions
//////////////////////////////////////////////

//
// Type definitions.
//

const
  SHREGDEL_DEFAULT = $00000000;       // Delete's HKCU, or HKLM if HKCU is not found.
  SHREGDEL_HKCU    = $00000001;       // Delete HKCU only
  SHREGDEL_HKLM    = $00000010;       // Delete HKLM only.
  SHREGDEL_BOTH    = $00000011;       // Delete both HKCU and HKLM.

type
  SHREGDEL_FLAGS = cardinal;

const
  SHREGENUM_DEFAULT = $00000000;       // Enumerates HKCU or HKLM if not found.
  SHREGENUM_HKCU    = $00000001;       // Enumerates HKCU only
  SHREGENUM_HKLM    = $00000010;       // Enumerates HKLM only.
  SHREGENUM_BOTH    = $00000011;       // Enumerates both HKCU and HKLM without duplicates.
                                       // This option is NYI.
type
  SHREGENUM_FLAGS = cardinal;

const
  SHREGSET_HKCU          = $00000001;       // Write to HKCU if empty.
  SHREGSET_FORCE_HKCU    = $00000002;       // Write to HKCU.
  SHREGSET_HKLM          = $00000004;       // Write to HKLM if empty.
  SHREGSET_FORCE_HKLM    = $00000008;       // Write to HKLM.
  SHREGSET_DEFAULT       = (SHREGSET_FORCE_HKCU or SHREGSET_HKLM);          // Default is SHREGSET_FORCE_HKCU | SHREGSET_HKLM.

type
  HUSKEY = THandle;  // HUSKEY is a Handle to a User Specific KEY.
  PHUSKEY = ^HUSKEY;

function SHRegCreateUSKeyA(const pszPath : PAnsiChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; dwFlags : cardinal) : integer; stdcall;
function SHRegCreateUSKeyW(const pszPath : PWideChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; dwFlags : cardinal) : integer; stdcall;
function SHRegCreateUSKey(const pszPath : PAnsiChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; dwFlags : cardinal) : integer; stdcall;

function SHRegOpenUSKeyA(const pszPath : PAnsiChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; fIgnoreHKCU : BOOL) : integer; stdcall;
function SHRegOpenUSKeyW(const pszPath : PWideChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; fIgnoreHKCU : BOOL) : integer; stdcall;
function SHRegOpenUSKey(const pszPath : PAnsiChar; samDesired : REGSAM; hRelativeUSKey : HUSKEY; phNewUSKey : PHUSKEY; fIgnoreHKCU : BOOL) : integer; stdcall;

function SHRegQueryUSValueA(USKey : HUSKEY; const pszValue : PAnsiChar; var pdwType : cardinal; pvData : Pointer; pcbData : PCardinal; fIgnoreHKCU : BOOL; pvDefaultData : Pointer; dwDefaultDataSize : cardinal) : integer; stdcall;
function SHRegQueryUSValueW(USKey : HUSKEY; const pszValue : PWideChar; var pdwType : cardinal; pvData : Pointer; pcbData : PCardinal; fIgnoreHKCU : BOOL; pvDefaultData : Pointer; dwDefaultDataSize : cardinal) : integer; stdcall;
function SHRegQueryUSValue(USKey : HUSKEY; const pszValue : PAnsiChar; var pdwType : cardinal; pvData : Pointer; pcbData : PCardinal; fIgnoreHKCU : BOOL; pvDefaultData : Pointer; dwDefaultDataSize : cardinal) : integer; stdcall;

function SHRegWriteUSValueA(USKey : HUSKEY; const pszValue : PAnsiChar; dwType : cardinal; const pvData : Pointer; cbData : cardinal; dwFlags : cardinal) : integer; stdcall;
function SHRegWriteUSValueW(USKey : HUSKEY; const pszValue : PWideChar; dwType : cardinal; const pvData : Pointer; cbData : cardinal; dwFlags : cardinal) : integer; stdcall;
function SHRegWriteUSValue(USKey : HUSKEY; const pszValue : PAnsiChar; dwType : cardinal; const pvData : Pointer; cbData : cardinal; dwFlags : cardinal) : integer; stdcall;

function SHRegDeleteUSValueA(USKey : HUSKEY; const pszValue : PAnsiChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;
function SHRegDeleteUSValueW(USKey : HUSKEY; const pszValue : PWideChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;
function SHRegDeleteUSValue(USKey : HUSKEY; const pszValue : PAnsiChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;

function SHRegDeleteEmptyUSKeyA(USKey : HUSKEY; const pszSubKey : PAnsiChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;
function SHRegDeleteEmptyUSKeyW(USKey : HUSKEY; const pszSubKey : PWideChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;
function SHRegDeleteEmptyUSKey(USKey : HUSKEY; const pszSubKey : PAnsiChar; delRegFlags : SHREGDEL_FLAGS) : integer; stdcall;

function SHRegEnumUSKeyA(USKey : HUSKEY; dwIndex : cardinal; pszName : PAnsiChar; pcchName : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegEnumUSKeyW(USKey : HUSKEY; dwIndex : cardinal; pszName : PWideChar; pcchName : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegEnumUSKey(USKey : HUSKEY; dwIndex : cardinal; pszName : PAnsiChar; pcchName : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;

function SHRegEnumUSValueA(USKey : HUSKEY; dwIndex : cardinal; pszValueName : PAnsiChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegEnumUSValueW(USKey : HUSKEY; dwIndex : cardinal; pszValueName : PWideChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegEnumUSValue(USKey : HUSKEY; dwIndex : cardinal; pszValueName : PAnsiChar; var pcchValueName,pdwType : cardinal; pvData : Pointer; var pcbData : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;

function SHRegQueryInfoUSKeyA(USKey : HUSKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegQueryInfoUSKeyW(USKey : HUSKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;
function SHRegQueryInfoUSKey(USKey : HUSKEY; pcSubKeys : PCardinal; var pcchMaxSubKeyLen : cardinal; pcValues : PCardinal; var pcchMaxValueNameLen : cardinal; enumRegFlags : SHREGENUM_FLAGS) : integer; stdcall;

function SHRegCloseUSKey(USKey : HUSKEY) : integer; stdcall;


// These calls are equal to an SHRegOpenUSKey, SHRegQueryUSValue, and then a SHRegCloseUSKey.
function SHRegGetUSValueA(const pszSubKey, pszValue : PAnsiChar; var pdwType : cardinal; pvData : pointer; var pcbData : cardinal; fIgnoreHKCU : bool; pvDefaultData : pointer; dwDefaultDataSize : cardinal) : integer; stdcall;
function SHRegGetUSValueW(const pszSubKey, pszValue : PWideChar; var pdwType : cardinal; pvData : pointer; var pcbData : cardinal; fIgnoreHKCU : bool; pvDefaultData : pointer; dwDefaultDataSize : cardinal) : integer; stdcall;
function SHRegGetUSValue(const pszSubKey, pszValue : PAnsiChar; var pdwType : cardinal; pvData : pointer; var pcbData : cardinal; fIgnoreHKCU : bool; pvDefaultData : pointer; dwDefaultDataSize : cardinal) : integer; stdcall;

function SHRegSetUSValueA(const pszSubKey, pszValue : PAnsiChar; dwType : cardinal; const pvData : Pointer; cbData, dwFlags : cardinal) : integer; stdcall;
function SHRegSetUSValueW(const pszSubKey, pszValue : PWideChar; dwType : cardinal; const pvData : Pointer; cbData, dwFlags : cardinal) : integer; stdcall;
function SHRegSetUSValue(const pszSubKey, pszValue : PAnsiChar; dwType : cardinal; const pvData : Pointer; cbData, dwFlags : cardinal) : integer; stdcall;

function SHRegGetIntW(hk : HKEY; pwzKey : PWideChar; iDefault : integer) : integer; stdcall;
function SHRegGetInt(hk : HKEY; pwzKey : PWideChar; iDefault : integer) : integer; stdcall;

function SHRegGetBoolUSValueA(const pszSubKey, pszValue : PAnsiChar; fIgnoreHKCU, fDefault : bool) : bool; stdcall;
function SHRegGetBoolUSValueW(const pszSubKey, pszValue : PWideChar; fIgnoreHKCU, fDefault : bool) : bool; stdcall;
function SHRegGetBoolUSValue(const pszSubKey, pszValue : PAnsiChar; fIgnoreHKCU, fDefault : bool) : bool; stdcall;

//
//  Association APIs
//
//  these APIs are to assist in accessing the data in HKCR
//  getting the Command strings and exe paths
//  for different verbs and extensions are simplified this way
//

const
  ASSOCF_INIT_NOREMAPCLSID    = $00000001;  //  do not remap clsids to progids
  ASSOCF_INIT_BYEXENAME       = $00000002;  //  executable is being passed in
  ASSOCF_OPEN_BYEXENAME       = $00000002;  //  executable is being passed in
  ASSOCF_INIT_DEFAULTTOSTAR   = $00000004;  //  treat "*" as the BaseClass
  ASSOCF_INIT_DEFAULTTOFOLDER = $00000008;  //  treat "Folder" as the BaseClass
  ASSOCF_NOUSERSETTINGS       = $00000010;  //  dont use HKCU
  ASSOCF_NOTRUNCATE           = $00000020;  //  dont truncate the return string
  ASSOCF_VERIFY               = $00000040;  //  verify data is accurate (DISK HITS)
  ASSOCF_REMAPRUNDLL          = $00000080;  //  actually gets info about rundlls target if applicable
  ASSOCF_NOFIXUPS             = $00000100;  //  attempt to fix errors if found
  ASSOCF_IGNOREBASECLASS      = $00000200;  //  dont recurse into the baseclass

type
  ASSOCF = cardinal;
  ASSOCSTR = cardinal;
  ASSOCKEY = cardinal;
  ASSOCDATA = cardinal;
  ASSOCENUM = cardinal;

const
  ASSOCSTR_COMMAND = 1;           //  shell\verb\command string
  ASSOCSTR_EXECUTABLE = 2;        //  the executable part of command string
  ASSOCSTR_FRIENDLYDOCNAME = 3;   //  friendly name of the document type
  ASSOCSTR_FRIENDLYAPPNAME = 4;   //  friendly name of executable
  ASSOCSTR_NOOPEN = 5;            //  noopen value
  ASSOCSTR_SHELLNEWVALUE = 6;     //  query values under the shellnew key
  ASSOCSTR_DDECOMMAND = 7;        //  template for DDE commands
  ASSOCSTR_DDEIFEXEC = 8;         //  DDECOMMAND to use if just create a process
  ASSOCSTR_DDEAPPLICATION = 9;    //  Application name in DDE broadcast
  ASSOCSTR_DDETOPIC = 10;         //  Topic Name in DDE broadcast
  ASSOCSTR_INFOTIP = 11;          //  info tip for an item, or list of properties to create info tip from
  ASSOCSTR_QUICKTIP = 12;         //  same as ASSOCSTR_INFOTIP, except, this list contains only quickly retrievable properties
  ASSOCSTR_TILEINFO = 13;         //  similar to ASSOCSTR_INFOTIP - lists important properties for tileview
  ASSOCSTR_CONTENTTYPE = 14;      //  MIME Content type
  ASSOCSTR_DEFAULTICON = 15;      //  Default icon source
  ASSOCSTR_SHELLEXTENSION = 16;   //  Guid string pointing to the Shellex\Shellextensionhandler value.
  ASSOCSTR_MAX = 17;              //  last item in enum...

const
  ASSOCKEY_SHELLEXECCLASS = 1;    //  the key that should be passed to ShellExec(hkeyClass)
  ASSOCKEY_APP = 2;               //  the "Application" key for the association
  ASSOCKEY_CLASS = 3;             //  the progid or class key
  ASSOCKEY_BASECLASS = 4;         //  the BaseClass key
  ASSOCKEY_MAX = 5;               //  last item in enum...

const
  ASSOCDATA_MSIDESCRIPTOR = 1;      //  Component Descriptor to pass to MSI APIs
  ASSOCDATA_NOACTIVATEHANDLER = 2;  //  restrict attempts to activate window
  ASSOCDATA_QUERYCLASSSTORE = 3;    //  should check with the NT Class Store
  ASSOCDATA_HASPERUSERASSOC = 4;    //  defaults to user specified association
  ASSOCDATA_EDITFLAGS = 5;          //  Edit flags.
  ASSOCDATA_VALUE = 6;              //  use pszExtra as the Value name
  ASSOCDATA_MAX = 7;

const
  ASSOCENUM_NONE = 0;

type
  IQueryAssociations = interface
    ['{c46ca590-3c3f-11d2-bee6-0000f805ca57}']
		function Init(flags : ASSOCF; pszAssoc : PWideChar; hkProgid : HKey; wnd : HWND) : HResult; stdcall;
		function GetString(flags : ASSOCF; str : ASSOCSTR; pszExtra : PWideChar; pszOut : PWideChar; var pcchOut : cardinal) : HResult; stdcall;
		function GetKey(flags : ASSOCF; key : ASSOCKEY; pszExtra : PWideChar; var phkeyOut : HKEY) : HResult; stdcall;
		function GetData(flags : ASSOCF; data : ASSOCDATA; pszExtra : PWideChar; pvOut : Pointer; var pcbOut : cardinal) : HResult; stdcall;
		function GetEnum(flags : ASSOCF; enum : ASSOCENUM; pszExtra : PWideChar; riid : TGUID; var ppvOut : pointer) : HResult; stdcall;
  end;

function AssocCreate(clsid : TClsId; const riid : TIID; out ppv) : HResult; stdcall;

function AssocQueryStringA(flags : ASSOCF; str : ASSOCSTR; const pszAssoc,pszExtra : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal) : HResult; stdcall;
function AssocQueryStringW(flags : ASSOCF; str : ASSOCSTR; const pszAssoc, pszExtra : PWideChar; pszOut : PWideChar; var pcchOut : cardinal) : HResult; stdcall;
function AssocQueryString(flags : ASSOCF; str : ASSOCSTR; const pszAssoc,pszExtra : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal) : HResult; stdcall;

function AssocQueryStringByKeyA(flags : ASSOCF; str : ASSOCSTR; hkAssoc : HKey; const pszExtra : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal) : HResult; stdcall;
function AssocQueryStringByKeyW(flags : ASSOCF; str : ASSOCSTR; hkAssoc : HKey; const pszExtra : PWideChar; pszOut : PWideChar; var pcchOut : cardinal) : HResult; stdcall;
function AssocQueryStringByKey(flags : ASSOCF; str : ASSOCSTR; hkAssoc : HKey; const pszExtra : PAnsiChar; pszOut : PAnsiChar; var pcchOut : cardinal) : HResult; stdcall;

function AssocQueryKeyA(flags : ASSOCF; str : ASSOCSTR; const pszAssoc, pszExtra : PAnsiChar; var phkeyOut : HKey) : HResult; stdcall;
function AssocQueryKeyW(flags : ASSOCF; str : ASSOCSTR; const pszAssoc, pszExtra : PWideChar; var phkeyOut : HKey) : HResult; stdcall;
function AssocQueryKey(flags : ASSOCF; str : ASSOCSTR; const pszAssoc, pszExtra : PAnsiChar; var phkeyOut : HKey) : HResult; stdcall;

function AssocIsDangerous(pszAssoc : PWideChar) : bool; stdcall;

const
  PERCEIVED_TYPE_CUSTOM          = -3;
  PERCEIVED_TYPE_UNSPECIFIED     = -2;
  PERCEIVED_TYPE_FOLDER          = -1;
  PERCEIVED_TYPE_UNKNOWN         = 0;
  PERCEIVED_TYPE_TEXT            = 1;
  PERCEIVED_TYPE_IMAGE           = 2;
  PERCEIVED_TYPE_AUDIO           = 3;
  PERCEIVED_TYPE_VIDEO           = 4;
  PERCEIVED_TYPE_COMPRESSED      = 5;
  PERCEIVED_TYPE_DOCUMENT        = 6;
  PERCEIVED_TYPE_SYSTEM          = 7;
  PERCEIVED_TYPE_APPLICATION     = 8;

type
  PERCEIVED = integer;

const
  PERCEIVEDFLAG_UNDEFINED     = $0000;
  PERCEIVEDFLAG_SOFTCODED     = $0001;
  PERCEIVEDFLAG_HARDCODED     = $0002;
  PERCEIVEDFLAG_NATIVESUPPORT = $0004;
  PERCEIVEDFLAG_GDIPLUS       = $0010;
  PERCEIVEDFLAG_WMSDK         = $0020;
  PERCEIVEDFLAG_ZIPFOLDER     = $0040;

type
  PERCEIVEDFLAG = cardinal;

function AssocGetPerceivedType(const pszExt : PWideChar; out ptype : PERCEIVED; out pFlag : PERCEIVEDFLAG; out ppszType : PWideChar) : HResult; stdcall;

//
//=============== Stream Routines ===================================
//
function SHOpenRegStreamA(key : HKEY; const pszSubkey, pszValue : PAnsiChar; grfMode : cardinal) : IStream; stdcall;
function SHOpenRegStreamW(key : HKEY; const pszSubkey, pszValue : PWideChar; grfMode : cardinal) : IStream; stdcall;
function SHOpenRegStream(key : HKEY; const pszSubkey, pszValue : PAnsiChar; grfMode : cardinal) : IStream; stdcall;
function SHOpenRegStream2A(key : HKEY; const pszSubkey, pszValue : PAnsiChar; grfMode : cardinal) : IStream; stdcall;
function SHOpenRegStream2W(key : HKEY; const pszSubkey, pszValue : PWideChar; grfMode : cardinal) : IStream; stdcall;
function SHOpenRegStream2(key : HKEY; const pszSubkey, pszValue : PAnsiChar; grfMode : cardinal) : IStream; stdcall;

function SHCreateStreamOnFileA(const pszFile : PAnsiChar; grfMode : cardinal; var ppStm : IStream) : HResult; stdcall;
function SHCreateStreamOnFileW(const pszFile : PWideChar; grfMode : cardinal; var ppStm : IStream) : HResult; stdcall;
function SHCreateStreamOnFile(const pszFile : PAnsiChar; grfMode : cardinal; var ppStm : IStream) : HResult; stdcall;

function SHCreateStreamOnFileEx(const pszFile : PWideChar; grfMode,dwAttributes : cardinal; fCreate : bool; pstmTemplate : IStream; var ppstm : IStream) : HResult; stdcall;

//
//=============== HTTP helper Routines ===================================
//
function GetAcceptLanguagesA(psz : PAnsiChar; var pcch : cardinal) : HResult; stdcall;
function GetAcceptLanguagesW(psz : PWideChar; var pcch : cardinal) : HResult; stdcall;
function GetAcceptLanguages(psz : PAnsiChar; var pcch : cardinal) : HResult; stdcall;

const
  SHGVSPB_PERUSER             = $00000001; // must have one of PERUSER or ALLUSERS
  SHGVSPB_ALLUSERS            = $00000002;
  SHGVSPB_PERFOLDER           = $00000004; // must have one of PERFOLDER ALLFOLDERS or INHERIT
  SHGVSPB_ALLFOLDERS          = $00000008;
  SHGVSPB_INHERIT             = $00000010;
  SHGVSPB_ROAM                = $00000020; // modifies the above
  SHGVSPB_NOAUTODEFAULTS      = $80000000; // turns off read delegation to more general property bags

  SHGVSPB_FOLDER              = (SHGVSPB_PERUSER or SHGVSPB_PERFOLDER);
  SHGVSPB_FOLDERNODEFAULTS    = (SHGVSPB_PERUSER or SHGVSPB_PERFOLDER or SHGVSPB_NOAUTODEFAULTS);
  SHGVSPB_USERDEFAULTS        = (SHGVSPB_PERUSER or SHGVSPB_ALLFOLDERS);
  SHGVSPB_GLOBALDEAFAULTS     = (SHGVSPB_ALLUSERS or SHGVSPB_ALLFOLDERS);

function SHGetViewStatePropertyBag(const pidl : PItemIdList; const pszBagName : PWideChar; dwFlags : cardinal; riid : TIID; out ppv) : HResult; stdcall;


// Shared memory apis

function SHAllocShared(const pvData : pointer; dwSize : cardinal; dwProcessId : cardinal) : THandle; stdcall;
function SHFreeShared(hData : THandle; dwProcessId : cardinal) : bool; stdcall;
function SHLockShared(hData : THandle; dwProcessId : cardinal) : pointer; stdcall;
function SHUnlockShared(pvData : pointer) : bool; stdcall;


// SHAutoComplete
//      hwndEdit - HWND of editbox, ComboBox or ComboBoxEx.
//      dwFlags - Flags to indicate what to AutoAppend or AutoSuggest for the editbox.
//
// WARNING:
//    Caller needs to have called CoInitialize() or OleInitialize()
//    and cannot call CoUninit/OleUninit until after
//    WM_DESTROY on hwndEdit.
//
//  dwFlags values:
const
  SHACF_DEFAULT                  = $00000000;  // Currently (SHACF_FILESYSTEM | SHACF_URLALL)
  SHACF_FILESYSTEM               = $00000001;  // This includes the File System as well as the rest of the shell (Desktop\My Computer\Control Panel\)
  SHACF_URLHISTORY               = $00000002;  // URLs in the User's History
  SHACF_URLMRU                   = $00000004;  // URLs in the User's Recently Used list.
  SHACF_URLALL                   = (SHACF_URLHISTORY or SHACF_URLMRU);
  SHACF_USETAB                   = $00000008;  // Use the tab to move thru the autocomplete possibilities instead of to the next dialog/window control.
  SHACF_FILESYS_ONLY             = $00000010;  // This includes the File System

  SHACF_FILESYS_DIRS             = $00000020;  // Same as SHACF_FILESYS_ONLY except it only includes directories, UNC servers, and UNC server shares.

  SHACF_AUTOSUGGEST_FORCE_ON     = $10000000;  // Ignore the registry default and force the feature on.
  SHACF_AUTOSUGGEST_FORCE_OFF    = $20000000;  // Ignore the registry default and force the feature off.
  SHACF_AUTOAPPEND_FORCE_ON      = $40000000;  // Ignore the registry default and force the feature on. (Also know as AutoComplete)
  SHACF_AUTOAPPEND_FORCE_OFF     = $80000000;  // Ignore the registry default and force the feature off. (Also know as AutoComplete)

function SHAutoComplete(hwndEdit : HWnd; dwFlags : cardinal) : HResult; stdcall;

function SHSetThreadRef(punk : IUnknown) : HResult; stdcall;
function SHGetThreadRef(var ppunk : IUnknown) : HResult; stdcall;

function SHSkipJunction(pbc : IBindCtx; clsid : PClsid) : bool; stdcall;

function SHCreateThreadRef(pcref : PInteger; var ppunk : IUnknown) : HResult; stdcall;

const
  CTF_INSIST          = 00000001;      // SHCreateThread() dwFlags - call pfnThreadProc synchronously if CreateThread() fails
  CTF_THREAD_REF      = 00000002;      // hold a reference to the creating thread
  CTF_PROCESS_REF     = 00000004;      // hold a reference to the creating process
  CTF_COINIT          = 00000008;      // init COM for the created thread
  CTF_FREELIBANDEXIT  = 00000010;      // hold a ref to the DLL and call FreeLibraryAndExitThread() when done
  CTF_REF_COUNTED     = 00000020;      // thread supports ref counting via SHGetThreadRef() or CTF_THREAD_REF so that child threads can keep this thread alive
  CTF_WAIT_ALLOWCOM   = 00000040;      // while waiting for pfnCallback, allow COM marshaling to the blocked calling thread

function SHCreateThread(pfnThreadProc : TThreadStartRoutine; pData : Pointer; dwFlags : cardinal; pfnCallback : TThreadStartRoutine) : Bool; stdcall;

function SHReleaseThreadRef : HResult; stdcall; // release a CTF_THREAD_REF reference earlier than the return of pfnThreadProc

//
//====== GDI helper functions  ================================================
//
function SHCreateShellPalette(dc : HDC) : HPalette; stdcall;

procedure ColorRGBToHLS(clrRGB : COLORREF; var pwHue, pwLuminance, pwSaturation : word); stdcall;
function ColorHLSToRGB(wHue, wLuminance, wSaturation : word) : COLORREF; stdcall;
function ColorAdjustLuma(clrRGB : COLORREF; n : integer; fScale : bool) : COLORREF; stdcall;

//
//====== DllGetVersion  =======================================================
//

type
  DLLVERSIONINFO = record
    cbSize : cardinal;
    dwMajorVersion : cardinal;                   // Major version
    dwMinorVersion : cardinal;                   // Minor version
    dwBuildNumber : cardinal;                    // Build number
    dwPlatformID : cardinal;                     // DLLVER_PLATFORM_*
  end;

// Platform IDs for DLLVERSIONINFO
const
  DLLVER_PLATFORM_WINDOWS         = $00000001;      // Windows 95
  DLLVER_PLATFORM_NT              = $00000002;      // Windows NT

type
  DLLVERSIONINFO2 = record
    info1 : DLLVERSIONINFO;
    dwFlags : cardinal;                          // No flags currently defined
    ullVersion : int64;                      // Encoded as:
                                             // Major 0xFFFF 0000 0000 0000
                                             // Minor 0x0000 FFFF 0000 0000
                                             // Build 0x0000 0000 FFFF 0000
                                             // QFE   0x0000 0000 0000 FFFF
  end;

const
  DLLVER_MAJOR_MASK                    = $FFFF000000000000;
  DLLVER_MINOR_MASK                    = $0000FFFF00000000;
  DLLVER_BUILD_MASK                    = $00000000FFFF0000;
  DLLVER_QFE_MASK                      = $000000000000FFFF;

function MAKEDLLVERULL(major, minor, build, qfe : cardinal) : int64;

type
  // The caller should always GetProcAddress("DllGetVersion"), not
  // implicitly link to it.
  TDLLGetVersion = function(var vi : DLLVERSIONINFO) : HResult; stdcall;

  // DllInstall (to be implemented by self-installing DLLs)
  TDllInstall = function(bInstall : boolean; const pszCmdLine : PWideChar) : HResult; stdcall;

// Function to see if Internet Explorer Enhanced Security Configuration is active for the current user
function IsInternetESCEnabled : Bool; stdcall;

// Undocumented (nit in ShlWapi.h) functions that are documented in msdn
const
  FDTF_SHORTTIME = $00000001;
  FDTF_SHORTDATE = $00000002;
  FDTF_DEFAULT   =  FDTF_SHORTDATE or FDTF_SHORTTIME;
  FDTF_LONGDATE  =  $00000004;
  FDTF_LONGTIME  =  $00000008;
  FDTF_RELATIVE  =  $00000010;
  FDTF_LTRDATE   =  $00000100;
  FDTF_RTLDATE   =  $00000200;

type
  TSHFormatDateTimeA = function(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PAnsiChar; cchBuf : UINT) : integer; stdcall;
  TSHFormatDateTimeW = function(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PWideChar; cchBuf : UINT) : integer; stdcall;

function ShFormatDateTimeA(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PAnsiChar; cchBuf : UINT) : integer; stdcall;
function ShFormatDateTimeW(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PWideChar; cchBuf : UINT) : integer; stdcall;
function ShFormatDateTime(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PAnsiChar; cchBuf : UINT) : integer; stdcall;

implementation

const
  shlwapilib = 'shlwapi.dll';

function StrChrA; external shlwapilib name 'StrChrA';
function StrChrW; external shlwapilib name 'StrChrW';
function StrChr; external shlwapilib name 'StrChrA';

function StrChrIA; external shlwapilib name 'StrChrIA';
function StrChrIW; external shlwapilib name 'StrChrIW';
function StrChrI; external shlwapilib name 'StrChrI';

function StrCmpNA; external shlwapilib name 'StrCmpNA';
function StrCmpNW; external shlwapilib name 'StrCmpNW';
function StrCmpN; external shlwapilib name 'StrCmpNA';

function StrCmpNIA; external shlwapilib name 'StrCmpNIA';
function StrCmpNIW; external shlwapilib name 'StrCmpNIW';
function StrCmpNI; external shlwapilib name 'StrCmpNIA';

function StrCSpnA; external shlwapilib name 'StrCSpnA';
function StrCSpnW; external shlwapilib name 'StrCSpnW';
function StrCSpn; external shlwapilib name 'StrCSpnA';

function StrCSpnIA; external shlwapilib name 'StrCSpnIA';
function StrCSpnIW; external shlwapilib name 'StrCSpnIW';
function StrCSpnI; external shlwapilib name 'StrCSpnIA';

function StrDupA; external shlwapilib name 'StrDupA';
function StrDupW; external shlwapilib name 'StrDupW';
function StrDup; external shlwapilib name 'StrDupA';

function StrFormatByteSizeA; external shlwapilib name 'StrFormatByteSizeA';
function StrFormatByteSizeW; external shlwapilib name 'StrFormatByteSizeW';
function StrFormatByteSize; external shlwapilib name 'StrFormatByteSizeA';
function StrFormatByteSize64A; external shlwapilib name 'StrFormatByteSize64A';
function StrFormatByteSize64; external shlwapilib name 'StrFormatByteSize64A';
function StrFormatKBSizeA; external shlwapilib name 'StrFormatKBSizeA';
function StrFormatKBSizeW; external shlwapilib name 'StrFormatKBSizeW';
function StrFormatKBSize; external shlwapilib name 'StrFormatKBSizeA';
function StrFromTimeIntervalA; external shlwapilib name 'StrFromTimeIntervalA';
function StrFromTimeIntervalW; external shlwapilib name 'StrFromTimeIntervalW';
function StrFromTimeInterval; external shlwapilib name 'StrFromTimeIntervalA';
function StrIsIntlEqualA; external shlwapilib name 'StrIsIntlEqualA';
function StrIsIntlEqualW; external shlwapilib name 'StrIsIntlEqualW';
function StrIsIntlEqual; external shlwapilib name 'StrIsIntlEqualA';
function StrNCatA; external shlwapilib name 'StrNCatA';
function StrNCatW; external shlwapilib name 'StrNCatW';
function StrNCat; external shlwapilib name 'StrNCatA';
function StrPBrkA; external shlwapilib name 'StrPBrkA';
function StrPBrkW; external shlwapilib name 'StrPBrkW';
function StrPBrk; external shlwapilib name 'StrPBrkA';
function StrRChrA; external shlwapilib name 'StrRChrA';
function StrRChrW; external shlwapilib name 'StrRChrW';
function StrRChr; external shlwapilib name 'StrRChrA';
function StrRChrIA; external shlwapilib name 'StrRChrIA';
function StrRChrIW; external shlwapilib name 'StrRChrIW';
function StrRChrI; external shlwapilib name 'StrRChrIA';
function StrRStrIA; external shlwapilib name 'StrRStrIA';
function StrRStrIW; external shlwapilib name 'StrRStrIW';
function StrRStrI; external shlwapilib name 'StrRStrIA';
function StrSpnA; external shlwapilib name 'StrSpnA';
function StrSpnW; external shlwapilib name 'StrSpnW';
function StrSpn; external shlwapilib name 'StrSpnA';
function StrStrA; external shlwapilib name 'StrStrA';
function StrStrW; external shlwapilib name 'StrStrW';
function StrStr; external shlwapilib name 'StrStrA';
function StrStrIA; external shlwapilib name 'StrStrIA';
function StrStrIW; external shlwapilib name 'StrStrIW';
function StrStrI; external shlwapilib name 'StrStrIA';
function StrToIntA; external shlwapilib name 'StrToIntA';
function StrToIntW; external shlwapilib name 'StrToIntW';
function StrToInt; external shlwapilib name 'StrToIntA';
function StrToIntExA; external shlwapilib name 'StrToIntExA';
function StrToIntExW; external shlwapilib name 'StrToIntExW';
function StrToIntEx; external shlwapilib name 'StrToIntExA';

function StrTrimA; external shlwapilib name 'StrTrimA';
function StrTrimW; external shlwapilib name 'StrTrimW';
function StrTrim; external shlwapilib name 'StrTrimA';
function StrCatW; external shlwapilib name 'StrCatW';
function StrCmpW; external shlwapilib name 'StrCmpW';
function StrCmpIW; external shlwapilib name 'StrCmpIW';
function StrCpyW; external shlwapilib name 'StrCpyW';
function StrCpyNW; external shlwapilib name 'StrCpyNW';

function StrCatBuffA; external shlwapilib name 'StrCatBuffA';
function StrCatBuffW; external shlwapilib name 'StrCatBuffW';
function StrCatBuff; external shlwapilib name 'StrCatBuffA';
function ChrCmpIA; external shlwapilib name 'ChrCmpIA';
function ChrCmpIW; external shlwapilib name 'ChrCmpIW';
function ChrCmpI; external shlwapilib name 'ChrCmpIA';
function wvnsprintfA; external shlwapilib name 'wvnsprintfA';
function wvnsprintfW; external shlwapilib name 'wvnsprintfW';
function wnsprintfA; external shlwapilib name 'wnsprintfA';
function wnsprintfW; external shlwapilib name 'wnsprintfW';
function StrRetToStrA; external shlwapilib name 'StrRetToStrA';
function StrRetToStrW; external shlwapilib name 'StrRetToStrW';
function StrRetToStr; external shlwapilib name 'StrRetToStrA';
function StrRetToBufA; external shlwapilib name 'StrRetToBufA';
function StrRetToBufW; external shlwapilib name 'StrRetToBufW';
function StrRetToBuf; external shlwapilib name 'StrRetToBufA';
function StrRetToBSTR; external shlwapilib name 'StrRetToBSTR';
function SHStrDupA; external shlwapilib name 'SHStrDupA';
function SHStrDupW; external shlwapilib name 'SHStrDupW';
function SHStrDup; external shlwapilib name 'SHStrDupA';
function StrCmpLogicalW; external shlwapilib name 'StrCmpLogicalW';
function StrCatChainW; external shlwapilib name 'StrCatChainW';
function SHLoadIndirectString; external shlwapilib name 'SHLoadIndirectString';
function IntlStrEqWorkerA; external shlwapilib name 'IntlStrEqWorkerA';
function IntlStrEqWorkerW; external shlwapilib name 'IntlStrEqWorkerW';
function IntlStrEqWorker; external shlwapilib name 'IntlStrEqWorkerA';

function PathAddBackslashA; external shlwapilib name 'PathAddBackslashA';
function PathAddBackslashW; external shlwapilib name 'PathAddBackslashW';
function PathAddBackslash; external shlwapilib name 'PathAddBackslashA';
function PathAddExtensionA; external shlwapilib name 'PathAddExtensionA';
function PathAddExtensionW; external shlwapilib name 'PathAddExtensionW';
function PathAddExtension; external shlwapilib name 'PathAddExtensionA';
function PathAppendA; external shlwapilib name 'PathAppendA';
function PathAppendW; external shlwapilib name 'PathAppendW';
function PathAppend; external shlwapilib name 'PathAppendA';
function PathBuildRootA; external shlwapilib name 'PathBuildRootA';
function PathBuildRootW; external shlwapilib name 'PathBuildRootW';
function PathBuildRoot; external shlwapilib name 'PathBuildRootA';
function PathCanonicalizeA; external shlwapilib name 'PathCanonicalizeA';
function PathCanonicalizeW; external shlwapilib name 'PathCanonicalizeW';
function PathCanonicalize; external shlwapilib name 'PathCanonicalizeA';
function PathCombineA; external shlwapilib name 'PathCombineA';
function PathCombineW; external shlwapilib name 'PathCombineW';
function PathCombine; external shlwapilib name 'PathCombineA';
function PathCompactPathA; external shlwapilib name 'PathCompactPathA';
function PathCompactPathW; external shlwapilib name 'PathCompactPathW';
function PathCompactPath; external shlwapilib name 'PathCompactPathA';
function PathCompactPathExA; external shlwapilib name 'PathCompactPathExA';
function PathCompactPathExW; external shlwapilib name 'PathCompactPathExW';
function PathCompactPathEx; external shlwapilib name 'PathCompactPathExA';
function PathCommonPrefixA; external shlwapilib name 'PathCommonPrefixA';
function PathCommonPrefixW; external shlwapilib name 'PathCommonPrefixW';
function PathCommonPrefix; external shlwapilib name 'PathCommonPrefixA';
function PathFileExistsA; external shlwapilib name 'PathFileExistsA';
function PathFileExistsW; external shlwapilib name 'PathFileExistsW';
function PathFileExists; external shlwapilib name 'PathFileExistsA';
function PathFindExtensionA; external shlwapilib name 'PathFindExtensionA';
function PathFindExtensionW; external shlwapilib name 'PathFindExtensionW';
function PathFindExtension; external shlwapilib name 'PathFindExtensionA';
function PathFindFileNameA; external shlwapilib name 'PathFindFileNameA';
function PathFindFileNameW; external shlwapilib name 'PathFindFileNameW';
function PathFindFileName; external shlwapilib name 'PathFindFileNameA';
function PathFindNextComponentA; external shlwapilib name 'PathFindNextComponentA';
function PathFindNextComponentW; external shlwapilib name 'PathFindNextComponentW';
function PathFindNextComponent; external shlwapilib name 'PathFindNextComponentA';
function PathFindOnPathA; external shlwapilib name 'PathFindOnPathA';
function PathFindOnPathW; external shlwapilib name 'PathFindOnPathW';
function PathFindOnPath; external shlwapilib name 'PathFindOnPathA';
function PathGetArgsA; external shlwapilib name 'PathGetArgsA';
function PathGetArgsW; external shlwapilib name 'PathGetArgsW';
function PathGetArgs; external shlwapilib name 'PathGetArgsA';
function PathFindSuffixArrayA; external shlwapilib name 'PathFindSuffixArrayA';
function PathFindSuffixArrayW; external shlwapilib name 'PathFindSuffixArrayW';
function PathFindSuffixArray; external shlwapilib name 'PathFindSuffixArrayA';
function PathIsLFNFileSpecA; external shlwapilib name 'PathIsLFNFileSpecA';
function PathIsLFNFileSpecW; external shlwapilib name 'PathIsLFNFileSpecW';
function PathIsLFNFileSpec; external shlwapilib name 'PathIsLFNFileSpecA';
function PathGetCharTypeA; external shlwapilib name 'PathGetCharTypeA';
function PathGetCharTypeW; external shlwapilib name 'PathGetCharTypeW';
function PathGetCharType; external shlwapilib name 'PathGetCharTypeA';
function PathGetDriveNumberA; external shlwapilib name 'PathGetDriveNumberA';
function PathGetDriveNumberW; external shlwapilib name 'PathGetDriveNumberW';
function PathGetDriveNumber; external shlwapilib name 'PathGetDriveNumberA';
function PathIsDirectoryA; external shlwapilib name 'PathIsDirectoryA';
function PathIsDirectoryW; external shlwapilib name 'PathIsDirectoryW';
function PathIsDirectory; external shlwapilib name 'PathIsDirectoryA';
function PathIsDirectoryEmptyA; external shlwapilib name 'PathIsDirectoryEmptyA';
function PathIsDirectoryEmptyW; external shlwapilib name 'PathIsDirectoryEmptyW';
function PathIsDirectoryEmpty; external shlwapilib name 'PathIsDirectoryEmptyA';
function PathIsFileSpecA; external shlwapilib name 'PathIsFileSpecA';
function PathIsFileSpecW; external shlwapilib name 'PathIsFileSpecW';
function PathIsFileSpec; external shlwapilib name 'PathIsFileSpecA';
function PathIsPrefixA; external shlwapilib name 'PathIsPrefixA';
function PathIsPrefixW; external shlwapilib name 'PathIsPrefixW';
function PathIsPrefix; external shlwapilib name 'PathIsPrefixA';
function PathIsRelativeA; external shlwapilib name 'PathIsRelativeA';
function PathIsRelativeW; external shlwapilib name 'PathIsRelativeW';
function PathIsRelative; external shlwapilib name 'PathIsRelativeA';
function PathIsRootA; external shlwapilib name 'PathIsRootA';
function PathIsRootW; external shlwapilib name 'PathIsRootW';
function PathIsRoot; external shlwapilib name 'PathIsRootA';
function PathIsSameRootA; external shlwapilib name 'PathIsSameRootA';
function PathIsSameRootW; external shlwapilib name 'PathIsSameRootW';
function PathIsSameRoot; external shlwapilib name 'PathIsSameRootA';
function PathIsUNCA; external shlwapilib name 'PathIsUNCA';
function PathIsUNCW; external shlwapilib name 'PathIsUNCW';
function PathIsUNC; external shlwapilib name 'PathIsUNCA';
function PathIsNetworkPathA; external shlwapilib name 'PathIsNetworkPathA';
function PathIsNetworkPathW; external shlwapilib name 'PathIsNetworkPathW';
function PathIsNetworkPath; external shlwapilib name 'PathIsNetworkPathA';
function PathIsUNCServerA; external shlwapilib name 'PathIsUNCServerA';
function PathIsUNCServerW; external shlwapilib name 'PathIsUNCServerW';
function PathIsUNCServer; external shlwapilib name 'PathIsUNCServerA';
function PathIsUNCServerShareA; external shlwapilib name 'PathIsUNCServerShareA';
function PathIsUNCServerShareW; external shlwapilib name 'PathIsUNCServerShareW';
function PathIsUNCServerShare; external shlwapilib name 'PathIsUNCServerShareA';
function PathIsContentTypeA; external shlwapilib name 'PathIsContentTypeA';
function PathIsContentTypeW; external shlwapilib name 'PathIsContentTypeW';
function PathIsContentType; external shlwapilib name 'PathIsContentTypeA';
function PathIsURLA; external shlwapilib name 'PathIsURLA';
function PathIsURLW; external shlwapilib name 'PathIsURLW';
function PathIsURL; external shlwapilib name 'PathIsURLA';
function PathMakePrettyA; external shlwapilib name 'PathMakePrettyA';
function PathMakePrettyW; external shlwapilib name 'PathMakePrettyW';
function PathMakePretty; external shlwapilib name 'PathMakePrettyA';
function PathMatchSpecA; external shlwapilib name 'PathMatchSpecA';
function PathMatchSpecW; external shlwapilib name 'PathMatchSpecW';
function PathMatchSpec; external shlwapilib name 'PathMatchSpecA';
function PathParseIconLocationA; external shlwapilib name 'PathParseIconLocationA';
function PathParseIconLocationW; external shlwapilib name 'PathParseIconLocationW';
function PathParseIconLocation; external shlwapilib name 'PathParseIconLocationA';
procedure PathQuoteSpacesA; external shlwapilib name 'PathQuoteSpacesA';
procedure PathQuoteSpacesW; external shlwapilib name 'PathQuoteSpacesW';
procedure PathQuoteSpaces; external shlwapilib name 'PathQuoteSpacesA';
function PathRelativePathToA; external shlwapilib name 'PathRelativePathToA';
function PathRelativePathToW; external shlwapilib name 'PathRelativePathToW';
function PathRelativePathTo; external shlwapilib name 'PathRelativePathToA';
procedure PathRemoveArgsA; external shlwapilib name 'PathRemoveArgsA';
procedure PathRemoveArgsW; external shlwapilib name 'PathRemoveArgsW';
procedure PathRemoveArgs; external shlwapilib name 'PathRemoveArgsA';
function PathRemoveBackslashA; external shlwapilib name 'PathRemoveBackslashA';
function PathRemoveBackslashW; external shlwapilib name 'PathRemoveBackslashW';
function PathRemoveBackslash; external shlwapilib name 'PathRemoveBackslashA';
procedure PathRemoveBlanksA; external shlwapilib name 'PathRemoveBlanksA';
procedure PathRemoveBlanksW; external shlwapilib name 'PathRemoveBlanksW';
procedure PathRemoveBlanks; external shlwapilib name 'PathRemoveBlanksA';
procedure PathRemoveExtensionA; external shlwapilib name 'PathRemoveExtensionA';
procedure PathRemoveExtensionW; external shlwapilib name 'PathRemoveExtensionW';
procedure PathRemoveExtension; external shlwapilib name 'PathRemoveExtensionA';
function PathRemoveFileSpecA; external shlwapilib name 'PathRemoveFileSpecA';
function PathRemoveFileSpecW; external shlwapilib name 'PathRemoveFileSpecW';
function PathRemoveFileSpec; external shlwapilib name 'PathRemoveFileSpecA';
function PathRenameExtensionA; external shlwapilib name 'PathRenameExtensionA';
function PathRenameExtensionW; external shlwapilib name 'PathRenameExtensionW';
function PathRenameExtension; external shlwapilib name 'PathRenameExtensionA';
function PathSearchAndQualifyA; external shlwapilib name 'PathSearchAndQualifyA';
function PathSearchAndQualifyW; external shlwapilib name 'PathSearchAndQualifyW';
function PathSearchAndQualify; external shlwapilib name 'PathSearchAndQualifyA';
procedure PathSetDlgItemPathA; external shlwapilib name 'PathSetDlgItemPathA';
procedure PathSetDlgItemPathW; external shlwapilib name 'PathSetDlgItemPathW';
procedure PathSetDlgItemPath; external shlwapilib name 'PathSetDlgItemPathA';
function PathSkipRootA; external shlwapilib name 'PathSkipRootA';
function PathSkipRootW; external shlwapilib name 'PathSkipRootW';
function PathSkipRoot; external shlwapilib name 'PathSkipRootA';
procedure PathStripPathA; external shlwapilib name 'PathStripPathA';
procedure PathStripPathW; external shlwapilib name 'PathStripPathW';
procedure PathStripPath; external shlwapilib name 'PathStripPathA';
function PathStripToRootA; external shlwapilib name 'PathStripToRootA';
function PathStripToRootW; external shlwapilib name 'PathStripToRootW';
function PathStripToRoot; external shlwapilib name 'PathStripToRootA';
procedure PathUnquoteSpacesA; external shlwapilib name 'PathUnquoteSpacesA';
procedure PathUnquoteSpacesW; external shlwapilib name 'PathUnquoteSpacesW';
procedure PathUnquoteSpaces; external shlwapilib name 'PathUnquoteSpacesA';
function PathMakeSystemFolderA; external shlwapilib name 'PathMakeSystemFolderA';
function PathMakeSystemFolderW; external shlwapilib name 'PathMakeSystemFolderW';
function PathMakeSystemFolder; external shlwapilib name 'PathMakeSystemFolderA';
function PathUnmakeSystemFolderA; external shlwapilib name 'PathUnmakeSystemFolderA';
function PathUnmakeSystemFolderW; external shlwapilib name 'PathUnmakeSystemFolderW';
function PathUnmakeSystemFolder; external shlwapilib name 'PathUnmakeSystemFolderA';
function PathIsSystemFolderA; external shlwapilib name 'PathIsSystemFolderA';
function PathIsSystemFolderW; external shlwapilib name 'PathIsSystemFolderW';
function PathIsSystemFolder; external shlwapilib name 'PathIsSystemFolderA';
procedure PathUndecorateA; external shlwapilib name 'PathUndecorateA';
procedure PathUndecorateW; external shlwapilib name 'PathUndecorateW';
procedure PathUndecorate; external shlwapilib name 'PathUndecorateA';
function PathUnExpandEnvStringsA; external shlwapilib name 'PathUnExpandEnvStringsA';
function PathUnExpandEnvStringsW; external shlwapilib name 'PathUnExpandEnvStringsW';
function PathUnExpandEnvStrings; external shlwapilib name 'PathUnExpandEnvStringsA';

function UrlCompareA; external shlwapilib name 'UrlCompareA';
function UrlCompareW; external shlwapilib name 'UrlCompareW';
function UrlCompare; external shlwapilib name 'UrlCompareA';
function UrlCombineA; external shlwapilib name 'UrlCombineA';
function UrlCombineW; external shlwapilib name 'UrlCombineW';
function UrlCombine; external shlwapilib name 'UrlCombineA';
function UrlCanonicalizeA; external shlwapilib name 'UrlCanonicalizeA';
function UrlCanonicalizeW; external shlwapilib name 'UrlCanonicalizeW';
function UrlCanonicalize; external shlwapilib name 'UrlCanonicalizeA';
function UrlIsOpaqueA; external shlwapilib name 'UrlIsOpaqueA';
function UrlIsOpaqueW; external shlwapilib name 'UrlIsOpaqueW';
function UrlIsOpaque; external shlwapilib name 'UrlIsOpaqueA';
function UrlIsNoHistoryA; external shlwapilib name 'UrlIsNoHistoryA';
function UrlIsNoHistoryW; external shlwapilib name 'UrlIsNoHistoryW';
function UrlIsNoHistory; external shlwapilib name 'UrlIsNoHistoryA';
function UrlIsA; external shlwapilib name 'UrlIsA';
function UrlIsW; external shlwapilib name 'UrlIsW';
function UrlIs; external shlwapilib name 'UrlIsA';
function UrlGetLocationA; external shlwapilib name 'UrlGetLocationA';
function UrlGetLocationW; external shlwapilib name 'UrlGetLocationW';
function UrlGetLocation; external shlwapilib name 'UrlGetLocationA';
function UrlUnescapeA; external shlwapilib name 'UrlUnescapeA';
function UrlUnescapeW; external shlwapilib name 'UrlUnescapeW';
function UrlUnescape; external shlwapilib name 'UrlUnescapeA';
function UrlEscapeA; external shlwapilib name 'UrlEscapeA';
function UrlEscapeW; external shlwapilib name 'UrlEscapeW';
function UrlEscape; external shlwapilib name 'UrlEscapeA';
function UrlCreateFromPathA; external shlwapilib name 'UrlCreateFromPathA';
function UrlCreateFromPathW; external shlwapilib name 'UrlCreateFromPathW';
function UrlCreateFromPath; external shlwapilib name 'UrlCreateFromPathA';
function PathCreateFromUrlA; external shlwapilib name 'PathCreateFromUrlA';
function PathCreateFromUrlW; external shlwapilib name 'PathCreateFromUrlW';
function PathCreateFromUrl; external shlwapilib name 'PathCreateFromUrlA';
function UrlHashA; external shlwapilib name 'UrlHashA';
function UrlHashW; external shlwapilib name 'UrlHashW';
function UrlHash; external shlwapilib name 'UrlHashA';
function UrlGetPartA; external shlwapilib name 'UrlGetPartA';
function UrlGetPartW; external shlwapilib name 'UrlGetPartW';
function UrlGetPart; external shlwapilib name 'UrlGetPartA';
function UrlApplySchemeA; external shlwapilib name 'UrlApplySchemeA';
function UrlApplySchemeW; external shlwapilib name 'UrlApplySchemeW';
function UrlApplyScheme; external shlwapilib name 'UrlApplySchemeA';
function HashData; external shlwapilib name 'HashData';

function SHDeleteEmptyKeyA; external shlwapilib name 'SHDeleteEmptyKeyA';
function SHDeleteEmptyKeyW; external shlwapilib name 'SHDeleteEmptyKeyW';
function SHDeleteEmptyKey; external shlwapilib name 'SHDeleteEmptyKeyA';
function SHDeleteKeyA; external shlwapilib name 'SHDeleteKeyA';
function SHDeleteKeyW; external shlwapilib name 'SHDeleteKeyW';
function SHDeleteKey; external shlwapilib name 'SHDeleteKeyA';
function SHRegDuplicateHKey; external shlwapilib name 'SHRegDuplicateHKey';
function SHDeleteValueA; external shlwapilib name 'SHDeleteValueA';
function SHDeleteValueW; external shlwapilib name 'SHDeleteValueW';
function SHDeleteValue; external shlwapilib name 'SHDeleteValueA';
function SHGetValueA; external shlwapilib name 'SHGetValueA';
function SHGetValueW; external shlwapilib name 'SHGetValueW';
function SHGetValue; external shlwapilib name 'SHGetValueA';
function SHSetValueA; external shlwapilib name 'SHSetValueA';
function SHSetValueW; external shlwapilib name 'SHSetValueW';
function SHSetValue; external shlwapilib name 'SHSetValueA';
function SHQueryValueExA; external shlwapilib name 'SHQueryValueExA';
function SHQueryValueExW; external shlwapilib name 'SHQueryValueExW'
function SHQueryValueEx; external shlwapilib name 'SHQueryValueExA';
function SHEnumKeyExA; external shlwapilib name 'SHEnumKeyExA';
function SHEnumKeyExW; external shlwapilib name 'SHEnumKeyExW';
function SHEnumKeyEx; external shlwapilib name 'SHEnumKeyExA';
function SHEnumValueA; external shlwapilib name 'SHEnumValueA';
function SHEnumValueW; external shlwapilib name 'SHEnumValueW';
function SHEnumValue; external shlwapilib name 'SHEnumValueA';
function SHQueryInfoKeyA; external shlwapilib name 'SHQueryInfoKeyA';
function SHQueryInfoKeyW; external shlwapilib name 'SHQueryInfoKeyW';
function SHQueryInfoKey; external shlwapilib name 'SHQueryInfoKeyA';
function SHCopyKeyA; external shlwapilib name 'SHCopyKeyA';
function SHCopyKeyw; external shlwapilib name 'SHCopyKeyW';
function SHCopyKey; external shlwapilib name 'SHCopyKeyA';
function SHRegGetPathA; external shlwapilib name 'SHRegGetPathA';
function SHRegGetPathW; external shlwapilib name 'SHRegGetPathW';
function SHRegGetPath; external shlwapilib name 'SHRegGetPathA';
function SHRegSetPathA; external shlwapilib name 'SHRegSetPathA';
function SHRegSetPathW; external shlwapilib name 'SHRegSetPathW';
function SHRegSetPath; external shlwapilib name 'SHRegSetPathA';
function SHRegCreateUSKeyA; external shlwapilib name 'SHRegCreateUSKeyA';
function SHRegCreateUSKeyW; external shlwapilib name 'SHRegCreateUSKeyW';
function SHRegCreateUSKey; external shlwapilib name 'SHRegCreateUSKeyA';
function SHRegOpenUSKeyA; external shlwapilib name 'SHRegOpenUSKeyA';
function SHRegOpenUSKeyW; external shlwapilib name 'SHRegOpenUSKeyW';
function SHRegOpenUSKey; external shlwapilib name 'SHRegOpenUSKeyA';
function SHRegQueryUSValueA; external shlwapilib name 'SHRegQueryUSValueA';
function SHRegQueryUSValueW; external shlwapilib name 'SHRegQueryUSValueW';
function SHRegQueryUSValue; external shlwapilib name 'SHRegQueryUSValueA';
function SHRegWriteUSValueA; external shlwapilib name 'SHRegWriteUSValueA';
function SHRegWriteUSValueW; external shlwapilib name 'SHRegWriteUSValueW';
function SHRegWriteUSValue; external shlwapilib name 'SHRegWriteUSValueA';
function SHRegDeleteUSValueA; external shlwapilib name 'SHRegDeleteUSValueA';
function SHRegDeleteUSValueW; external shlwapilib name 'SHRegDeleteUSValueW';
function SHRegDeleteUSValue; external shlwapilib name 'SHRegDeleteUSValueA';
function SHRegDeleteEmptyUSKeyA; external shlwapilib name 'SHRegDeleteEmptyUSKeyA';
function SHRegDeleteEmptyUSKeyW; external shlwapilib name 'SHRegDeleteEmptyUSKeyW';
function SHRegDeleteEmptyUSKey; external shlwapilib name 'SHRegDeleteEmptyUSKeyA';
function SHRegEnumUSKeyA; external shlwapilib name 'SHRegEnumUSKeyA';
function SHRegEnumUSKeyW; external shlwapilib name 'SHRegEnumUSKeyW';
function SHRegEnumUSKey; external shlwapilib name 'SHRegEnumUSKeyA';
function SHRegEnumUSValueA; external shlwapilib name 'SHRegEnumUSValueA';
function SHRegEnumUSValueW; external shlwapilib name 'SHRegEnumUSValueW';
function SHRegEnumUSValue; external shlwapilib name 'SHRegEnumUSValueA';
function SHRegQueryInfoUSKeyA; external shlwapilib name 'SHRegQueryInfoUSKeyA';
function SHRegQueryInfoUSKeyW; external shlwapilib name 'SHRegQueryInfoUSKeyW';
function SHRegQueryInfoUSKey; external shlwapilib name 'SHRegQueryInfoUSKeyA';
function SHRegCloseUSKey; external shlwapilib name 'SHRegCloseUSKey';
function SHRegGetUSValueA; external shlwapilib name 'SHRegGetUSValueA';
function SHRegGetUSValueW; external shlwapilib name 'SHRegGetUSValueW';
function SHRegGetUSValue; external shlwapilib name 'SHRegGetUSValueA';
function SHRegSetUSValueA; external shlwapilib name 'SHRegSetUSValueA';
function SHRegSetUSValueW; external shlwapilib name 'SHRegSetUSValueW';
function SHRegSetUSValue; external shlwapilib name 'SHRegSetUSValueA';
function SHRegGetIntW; external shlwapilib name 'SHRegGetIntW';
function SHRegGetInt; external shlwapilib name 'SHRegGetIntW';
function SHRegGetBoolUSValueA; external shlwapilib name 'SHRegGetBoolUSValueA';
function SHRegGetBoolUSValueW; external shlwapilib name 'SHRegGetBoolUSValueW';
function SHRegGetBoolUSValue; external shlwapilib name 'SHRegGetBoolUSValueA';

function AssocCreate; external shlwapilib name 'AssocCreate';
function AssocQueryStringA; external shlwapilib name 'AssocQueryStringA';
function AssocQueryStringW; external shlwapilib name 'AssocQueryStringW';
function AssocQueryString; external shlwapilib name 'AssocQueryStringA';
function AssocQueryStringByKeyA; external shlwapilib name 'AssocQueryStringByKeyA';
function AssocQueryStringByKeyW; external shlwapilib name 'AssocQueryStringByKeyW';
function AssocQueryStringByKey; external shlwapilib name 'AssocQueryStringByKeyA';
function AssocQueryKeyA; external shlwapilib name 'AssocQueryKeyA';
function AssocQueryKeyW; external shlwapilib name 'AssocQueryKeyW';
function AssocQueryKey; external shlwapilib name 'AssocQueryKeyA';

function SHOpenRegStreamA; external shlwapilib name 'SHOpenRegStreamA';
function SHOpenRegStreamW; external shlwapilib name 'SHOpenRegStreamW';
function SHOpenRegStream; external shlwapilib name 'SHOpenRegStreamA';
function SHOpenRegStream2A; external shlwapilib name 'SHOpenRegStream2A';
function SHOpenRegStream2W; external shlwapilib name 'SHOpenRegStream2W';
function SHOpenRegStream2; external shlwapilib name 'SHOpenRegStream2A';
function SHCreateStreamOnFileA; external shlwapilib name 'SHCreateStreamOnFileA';
function SHCreateStreamOnFileW; external shlwapilib name 'SHCreateStreamOnFileW';
function SHCreateStreamOnFile; external shlwapilib name 'SHCreateStreamOnFileA';
function SHAutoComplete; external shlwapilib name 'SHAutoComplete';
function SHSetThreadRef; external shlwapilib name 'SHSetThreadRef';
function SHGetThreadRef; external shlwapilib name 'SHGetThreadRef';
function SHSkipJunction; external shlwapilib name 'SHSkipJunction';
function SHCreateThread; external shlwapilib name 'SHCreateThread';
function SHReleaseThreadRef; external shlwapilib name 'SHReleaseThreadRef';
function SHCreateShellPalette; external shlwapilib name 'SHCreateShellPalette';
procedure ColorRGBToHLS; external shlwapilib name 'ColorRGBToHLS';
function ColorHLSToRGB; external shlwapilib name 'ColorHLSToRGB';
function ColorAdjustLuma; external shlwapilib name 'ColorAdjustLuma';


function StrToInt64ExA(const pszString : PAnsiChar; dwFlags : cardinal; var pllRet : int64) : bool;
var
  _StrToInt64ExA : function(const pszString : PAnsiChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_StrToInt64ExA := GetProcAddress(Dll, 'StrToInt64ExA');
		if Assigned(_StrToInt64ExA) then
			Result := _StrToInt64ExA(pszString, dwFlags, pllRet);

		FreeLibrary(Dll);
  end;
end;

function StrToInt64ExW(const pszString : PWideChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
var
  _StrToInt64ExW : function (const pszString : PWideChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_StrToInt64ExW := GetProcAddress(Dll, 'StrToInt64ExW');
		if Assigned(_StrToInt64ExW) then
			Result := _StrToInt64ExW(pszString, dwFlags, pllRet);

		FreeLibrary(Dll);
  end;
end;

function StrToInt64Ex(const pszString : PAnsiChar; dwFlags : cardinal; var pllRet : int64) : bool; stdcall;
begin
  Result := StrToInt64ExA(pszString, dwFlags, pllRet);
end;

function IsCharSpaceA(wch : AnsiChar) : bool; stdcall;
var
  temp : WideString;
begin
  temp := wch;
  Result := IsCharSpaceW(temp[1]);
end;

function IsCharSpaceW(wch : WideChar) : bool; stdcall;
var
  _IsCharSpaceW : function(wch : WideChar) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_IsCharSpaceW := GetProcAddress(Dll, MakeIntresource(29));
		if Assigned(_IsCharSpaceW) then
			Result := _IsCharSpacew(wch);

		FreeLibrary(Dll);
  end;
end;

function IsCharSpace(wch : AnsiChar) : bool; stdcall;
begin
  Result := IsCharSpaceA(wch);
end;

function SHRegGetValueA(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
var
  _SHRegGetValueA : function(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
  Dll : THandle;
begin
  Result := ERROR_PROC_NOT_FOUND;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHRegGetValueA := GetProcAddress(Dll, 'SHRegGetValueA');
		if Assigned(_SHRegGetValueA) then
			Result := _SHRegGetValueA(key, pszSubKey, pszValue,dwFlags,pdwType,pvData,pcbData);

		FreeLibrary(Dll);

  end;
end;

function SHRegGetValueW(key : HKEY; const pszSubKey, pszValue : PWideChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
var
  _SHRegGetValueW : function(key : HKEY; const pszSubKey, pszValue : PWideChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
  Dll : THandle;
begin
  Result := ERROR_PROC_NOT_FOUND;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHRegGetValueW := GetProcAddress(Dll, 'SHRegGetValueW');
		if Assigned(_SHRegGetValueW) then
			Result := _SHRegGetValueW(key, pszSubKey, pszValue,dwFlags,pdwType,pvData,pcbData);

		FreeLibrary(Dll);

  end;
end;

function SHRegGetValue(key : HKEY; const pszSubKey, pszValue : PAnsiChar; dwFlags : SRRF; var pdwType : cardinal; pvData : Pointer; var pcbData : cardinal) : integer; stdcall;
begin
  Result := ShRegGetValueA(key, pszSubKey, pszValue,dwFlags,pdwType,pvData,pcbData);
end;

function AssocIsDangerous(pszAssoc : PWideChar) : bool; stdcall;
var
  _AssocIsDangerous : function(pszAssoc : PWideChar) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_AssocIsDangerous := GetProcAddress(Dll, 'AssocIsDangerous');
		if Assigned(_AssocIsDangerous) then
			Result := _AssocIsDangerous(pszAssoc);

		FreeLibrary(Dll);
  end;
end;

function AssocGetPerceivedType(const pszExt : PWideChar; out ptype : PERCEIVED; out pFlag : PERCEIVEDFLAG; out ppszType : PWideChar) : HResult; stdcall;
var
  _AssocGetPerceivedType : function(const pszExt : PWideChar; out ptype : PERCEIVED; out pFlag : PERCEIVEDFLAG; out ppszType : PWideChar) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_AssocGetPerceivedType := GetProcAddress(Dll, 'AssocGetPerceivedType');
		if Assigned(_AssocGetPerceivedType) then
			Result := _AssocGetPerceivedType(pszExt,ptype,pFlag,ppszType);

		FreeLibrary(Dll);
  end;
end;

function SHCreateStreamOnFileEx(const pszFile : PWideChar; grfMode,dwAttributes : cardinal; fCreate : bool; pstmTemplate : IStream; var ppstm : IStream) : HResult; stdcall;
var
  _SHCreateStreamOnFileEx : function(const pszFile : PWideChar; grfMode,dwAttributes : cardinal; fCreate : bool; pstmTemplate : IStream; var ppstm : IStream) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHCreateStreamOnFileEx := GetProcAddress(Dll, 'SHCreateStreamOnFileEx');
		if Assigned(_SHCreateStreamOnFileEx) then
			Result := _SHCreateStreamOnFileEx(pszFile,grfMode,dwAttributes,fCreate,pstmTemplate,ppstm);

		FreeLibrary(Dll);
  end;
end;

function GetAcceptLanguagesA(psz : PAnsiChar; var pcch : cardinal) : HResult; stdcall;
var
  _GetAcceptLanguagesA : function(psz : PAnsiChar; var pcch : cardinal) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_GetAcceptLanguagesA := GetProcAddress(Dll, MakeIntResource(14));
		if Assigned(_GetAcceptLanguagesA) then
			Result := _GetAcceptLanguagesA(psz,pcch);

		FreeLibrary(Dll);
  end;
end;

function GetAcceptLanguagesW(psz : PWideChar; var pcch : cardinal) : HResult; stdcall;
var
  _GetAcceptLanguagesW : function(psz : PWideChar; var pcch : cardinal) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_GetAcceptLanguagesW := GetProcAddress(Dll, MakeIntResource(15));
		if Assigned(_GetAcceptLanguagesW) then
			Result := _GetAcceptLanguagesW(psz,pcch);

		FreeLibrary(Dll);
  end;
end;

function GetAcceptLanguages(psz : PAnsiChar; var pcch : cardinal) : HResult; stdcall;
begin
  Result := GetAcceptLanguagesA(psz,pcch);
end;

function SHGetViewStatePropertyBag(const pidl : PItemIdList; const pszBagName : PWideChar; dwFlags : cardinal; riid : TIID; out ppv) : HResult; stdcall;
var
  _SHGetViewStatePropertyBag : function(const pidl : PItemIdList; const pszBagName : PWideChar; dwFlags : cardinal; riid : TIID; out ppv) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHGetViewStatePropertyBag := GetProcAddress(Dll, 'SHGetViewStatePropertyBag');
		if Assigned(_SHGetViewStatePropertyBag) then
			Result := _SHGetViewStatePropertyBag(pidl,pszBagName,dwFlags,riid,ppv);

		FreeLibrary(Dll);
  end;
end;

function SHAllocShared(const pvData : pointer; dwSize : cardinal; dwProcessId : cardinal) : THandle; stdcall;
var
  _SHAllocShared : function(const pvData : pointer; dwSize : cardinal; dwProcessId : cardinal) : THandle; stdcall;
  Dll : THandle;
begin
  Result := 0;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHAllocShared := GetProcAddress(Dll, 'SHAllocShared');
		if Assigned(_SHAllocShared) then
			Result := _SHAllocShared(pvData,dwSize,dwProcessId);

		FreeLibrary(Dll);
  end;
end;

function SHFreeShared(hData : THandle; dwProcessId : cardinal) : bool; stdcall;
var
  _SHFreeShared : function(hData : THandle; dwProcessId : cardinal) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHFreeShared := GetProcAddress(Dll, 'SHFreeShared');
		if Assigned(_SHFreeShared) then
			Result := _SHFreeShared(hData,dwProcessId);

		FreeLibrary(Dll);
  end;
end;

function SHLockShared(hData : THandle; dwProcessId : cardinal) : pointer; stdcall;
var
  _SHLockShared : function(hData : THandle; dwProcessId : cardinal) : pointer; stdcall;
  Dll : THandle;
begin
  Result := nil;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHLockShared := GetProcAddress(Dll, 'SHLockShared');
		if Assigned(_SHLockShared) then
			Result := _SHLockShared(hData,dwProcessId);

		FreeLibrary(Dll);
  end;
end;

function SHUnlockShared(pvData : pointer) : bool; stdcall;
var
  _SHUnlockShared : function(pvData : pointer) : bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHUnlockShared := GetProcAddress(Dll, 'SHUnlockShared');
		if Assigned(_SHUnlockShared) then
			Result := _SHUnlockShared(pvData);

		FreeLibrary(Dll);
  end;
end;

function SHCreateThreadRef(pcref : PInteger; var ppunk : IUnknown) : HResult; stdcall;
var
  _SHCreateThreadRef : function(pcref : PInteger; var ppunk : IUnknown) : HResult; stdcall;
  Dll : THandle;
begin
  Result := CTL_E_ILLEGALFUNCTIONCALL;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_SHCreateThreadRef := GetProcAddress(Dll, 'SHCreateThreadRef');
		if Assigned(_SHCreateThreadRef) then
			Result := _SHCreateThreadRef(pcref,ppunk);

		FreeLibrary(Dll);
  end;
end;

function IsInternetESCEnabled : Bool; stdcall;
var
  _IsInternetESCEnabled : function : Bool; stdcall;
  Dll : THandle;
begin
  Result := false;
	Dll := LoadLibrary(shlwapilib);
	if (Dll <> 0) then
  begin
		_IsInternetESCEnabled := GetProcAddress(Dll, 'IsInternetESCEnabled');
		if Assigned(_IsInternetESCEnabled) then
			Result := _IsInternetESCEnabled;

		FreeLibrary(Dll);
  end;
end;

function MAKEDLLVERULL(major, minor, build, qfe : cardinal) : int64;
begin
  Result := (Int64(major) shl 48) or (Int64(minor) shl 32) or (build shl 16) or qfe;
end;

function UrlIsFileUrlA(pszURL : PAnsiChar) : bool;
begin
  Result := UrlIsA(pszURL, URLIS_FILEURL);
end;

function UrlIsFileUrlW(pszURL : PWideChar) : bool;
begin
  Result := UrlIsW(pszURL, URLIS_FILEURL);
end;

function UrlIsFileUrl(pszURL : PAnsiChar) : bool;
begin
  Result := UrlIs(pszURL, URLIS_FILEURL);
end;

function UrlEscapeSpacesA(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; pcchEscaped : cardinal): HResult;
begin
  Result := UrlCanonicalizeA(pszUrl, pszEscaped, pcchEscaped, URL_ESCAPE_SPACES_ONLY or URL_DONT_ESCAPE_EXTRA_INFO);
end;

function UrlEscapeSpacesW(const pszUrl : PWideChar; pszEscaped : PWideChar; pcchEscaped : cardinal): HResult;
begin
  Result := UrlCanonicalizeW(pszUrl, pszEscaped, pcchEscaped, URL_ESCAPE_SPACES_ONLY or URL_DONT_ESCAPE_EXTRA_INFO);
end;

function UrlEscapeSpaces(const pszUrl : PAnsiChar; pszEscaped : PAnsiChar; pcchEscaped : cardinal): HResult;
begin
  Result := UrlCanonicalize(pszUrl, pszEscaped, pcchEscaped, URL_ESCAPE_SPACES_ONLY or URL_DONT_ESCAPE_EXTRA_INFO);
end;

function UrlUnescapeInPlaceA(pszUrl : PAnsiChar; dwFlags : cardinal) : HResult;
var
  temp : cardinal;
begin
  Result := UrlUnescapeA(pszUrl, nil, temp, dwFlags or URL_UNESCAPE_INPLACE);
end;

function UrlUnescapeInPlaceW(pszUrl : PWideChar; dwFlags : cardinal) : HResult;
var
  temp : cardinal;
begin
  Result := UrlUnescapeW(pszUrl, nil, temp, dwFlags or URL_UNESCAPE_INPLACE);
end;

function UrlUnescapeInPlace(pszUrl : PAnsiChar; dwFlags : cardinal) : HResult;
var
  temp : cardinal;
begin
  Result := UrlUnescape(pszUrl, nil, temp, dwFlags or URL_UNESCAPE_INPLACE);
end;

function StrIntlEqNA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqualA( TRUE, s1, s2, nChar);
end;

function StrIntlEqNW(const s1, s2 : PWideChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqualW( TRUE, s1, s2, nChar);
end;

function StrIntlEqN(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqual( TRUE, s1, s2, nChar);
end;

function StrIntlEqNIA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqualA( false, s1, s2, nChar);
end;

function StrIntlEqNIW(const s1, s2 : PWideChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqualW( false, s1, s2, nChar);
end;

function StrIntlEqNI(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := StrIsIntlEqual( false, s1, s2, nChar);
end;

function IntlStrEqNA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorkerA( true, s1, s2, nChar);
end;

function IntlStrEqNW(const s1, s2 : PWideChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorkerW( true, s1, s2, nChar);
end;

function IntlStrEqN(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorker( true, s1, s2, nChar);
end;

function IntlStrEqNIA(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorkerA( false, s1, s2, nChar);
end;

function IntlStrEqNIW(const s1, s2 : PWideChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorkerW( false, s1, s2, nChar);
end;

function IntlStrEqNI(const s1, s2 : PAnsiChar; nChar : integer) : bool;
begin
  Result := IntlStrEqWorker( false, s1, s2, nChar);
end;

function PathIsHTMLFileA(const pszPath : PAnsiChar) : bool;
begin
  Result := PathIsContentTypeA(pszPath, SZ_CONTENTTYPE_HTML);
end;

function PathIsHTMLFileW(const pszPath : PWideChar) : bool;
begin
  Result := PathIsContentTypeW(pszPath, SZ_CONTENTTYPE_HTML);
end;

function PathIsHTMLFile(const pszPath : PAnsiChar) : bool;
begin
  Result := PathIsContentType(pszPath, SZ_CONTENTTYPE_HTML);
end;

function ShFormatDateTimeA(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PAnsiChar; cchBuf : UINT) : integer;
var
  hShlWapi : THandle;
  sfd : TShFormatDateTimeA;
begin
  Result := E_NOTIMPL;
  hShlWapi := LoadLibrary('shlwapi.dll');
  try
    if (hShlWapi <> 0) then
    begin
      @sfd := GetProcAddress(hShlWapi, MakeIntResource(353));
      if Assigned(@sfd) then
        Result := sfd(pft,pdwFlags,pszBuf,cchBuf);
    end;
  finally
    FreeLibrary(hShlWapi);
  end;
end;

function ShFormatDateTimeW(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PWideChar; cchBuf : UINT) : integer;
var
  hShlWapi : THandle;
  sfd : TShFormatDateTimeW;
begin
  Result := E_NOTIMPL;
  hShlWapi := LoadLibrary('shlwapi.dll');
  try
    if (hShlWapi <> 0) then
    begin
      @sfd := GetProcAddress(hShlWapi, MakeIntResource(354));
      if Assigned(@sfd) then
        Result := sfd(pft,pdwFlags,pszBuf,cchBuf);
    end;
  finally
    FreeLibrary(hShlWapi);
  end;
end;

function ShFormatDateTime(pft : PFILETIME; pdwFlags : PDWORD; pszBuf : PAnsiChar; cchBuf : UINT) : integer;
begin
  Result := ShFormatDateTimeA(pft,pdwflags,pszbuf,cchbuf);
end;

end.
